library import_ozone;

uses
  {$IFDEF WIN32}
   ShareMem,
  {$ENDIF}
  SysUtils,
  Classes,
  o3world,
  o3objects,
  o3stones,
  o3actors,
  o3item,
  o3utils,
  o3levelinterface,
  odeimport,
  o3game,
  o3basicobj;
type
TAlias = record
 a:string;
 c:char;
end;
PAlias = ^TAlias;
TAliasList = class
 fList:TList;
 cc:char;
 constructor Create;
 destructor Destory;
 function add(a:string):char;
 function get(a:string):char;
end;
{$LIBPREFIX ''}

function TAliasList.get;
var x:integer;
    al:PAlias;
begin
 Result:=#0;
 if fList.Count<=0 then EXIT;
 for x:=0 to fList.Count-1 do begin
  al:=fList[x];
  if(al.a=a) then begin
   Result:=al.c;
   EXIT;
  end;
 end;
end;

function TAliasList.add;
var al:PAlias;
begin
 New(al);
 al.c:=cc;
 al.a:=a;
 fList.Add(al);
 Result:=cc;
 cc:=Chr(Ord(cc)+1);
end;

constructor TAliasList.Create;
begin
 inherited Create;
 FList:=TList.Create;
 cc:=#35;
end;

destructor TAliasList.Destory;
var x:integer;
    al:PAlias;
begin
 if FList.Count>0 then
  for x:=0 to FList.Count-1 do begin
   al:=FList[x];
   Dispose(al);
  end;
 FList.Clear;
 FList.Free;
 inherited Destroy;
end;


procedure LoadLevel(params:string;level:pointer);
var f:TextFile;
    outfile:TextFile;
    s:string;
    t:string;
    src,dst:string;
    srcC:TGameObject;
    sigC:TSignal;
    c:char;
    aliasit:array[#0..#255] of string;
    aliasst:array[#0..#255] of string;
    x,y,z:integer;
    loadActor:TActor;
begin
 with TLevel(level) do begin
 for c:=#0 to #255 do begin
  aliasit[c]:='nil';
  aliasst[c]:='nil';
 end;
 FX:=0;
 FY:=0;
 FZ:=0;
 SetLength(FCells,FX,FY,FZ);
 AssignFile(f,getToken(params,1,','));
 Reset(f);
 while(not Eof(f)) do begin
   ReadLn(f,s);
   t:=GetToken(s,1,' ');
   if t='aliasst' then aliasst[GetToken(s,2,' ')[1]]:=GetToken(s,3,' ');
   if t='aliasit' then aliasit[GetToken(s,2,' ')[1]]:=GetToken(s,3,' ');
   if t='xsize' then begin
    FX:=StrToInt(GetToken(s,2,' '));
    SetLength(FCells,FX,FY,FZ);
   end;
   if t='ysize' then begin
    FY:=StrToInt(GetToken(s,2,' '));
    SetLength(FCells,FX,FY,FZ);
   end;
   if t='zsize' then begin
    FZ:=StrToInt(GetToken(s,2,' '));
    SetLength(FCells,FX,FY,FZ);
   end;
   if t='gravity' then begin
    DecimalSeparator:='.';
    dWorldSetGravity(TLevel(level).Physics.theWorld,StrToFloat(GetToken(s,2,' ')),StrToFloat(GetToken(s,3,' ')),StrToFloat(GetToken(s,4,' ')));
   end;
   if t='signal' then begin
    src:=GetToken(s,2,' ');
    dst:=GetToken(s,3,' ');
    srcc:=GetObjectFromCSV(src,level);
    sigc:=Signals.find(srcc);
    if sigc=nil then begin
     sigc:=TSignal.create;
     sigc.source:=srcc;
     Signals.FList.Add(sigc);
    end;
    sigc.targets.Add(GetObjectFromCSV(dst,level));
//    DecimalSeparator:='.';

//    dWorldSetGravity(TLevel(level).Physics.theWorld,StrToFloat(GetToken(s,2,' ')),StrToFloat(GetToken(s,3,' ')),StrToFloat(GetToken(s,4,' ')));
   end;
   if t='actor' then begin
    DecimalSeparator:='.';
    loadActor:=MakeActor( GetToken(s,2,' '),
                             StrToFloat(GetToken(s,3,' ')),
                             StrToFloat(GetToken(s,4,' ')),
                             StrToFloat(GetToken(s,5,' ')),
                             Level,
                             GetToken(s,8,' '));
    loadActor.Owner:=level;
    t:=GetToken(s,6,' ');
    loadActor.name:=GetToken(s,7,' ');
    loadActor.ControlProc:=nil;
    if t='firstplayer' then begin
     loadActor.ControlProc:=TOzoneMainClass(owner).controls.GetSteer('1');
     theActorToFollow:=loadActor;
    end
    else if (t='$firstplayer') then
     loadActor.ControlProc:=TOzoneMainClass(owner).controls.GetSteer('1')
    else if t='secondplayer' then begin
     loadActor.ControlProc:=TOzoneMainClass(owner).controls.GetSteer('2');
     theActorToFollow2:=loadActor;
    end
    else if (t='$secondplayer') then
     loadActor.ControlProc:=TOzoneMainClass(owner).controls.GetSteer('2');
    loadActor.Info['control']:=t;
    FActors.AddActor(loadActor,GetToken(s,7,' '));
   end;
   if t='stmap' then begin
    if (FX>0)and(FY>0)and(FZ>0) then begin
     for y:=0 to FY-1 do begin
      for z:=0 to FZ-1 do begin
       t:=GetToken(s,2+y*FZ+z,' ');
       for x:=0 to FX-1 do begin
        if FCells[x,y,z]=nil then
         FCells[x,y,z]:=TCell.Create('nil','nil',TLevel(level));
        if aliasst[t[x+1]]='st-getpos' then begin
         Assign(outfile,'import_ozone.log');
         Rewrite(outfile);
         WriteLn(outfile,format('got st-getpos at position: %d,%d,%d',[x,y,z]));
         Close(outfile);
         continue;
        end;
        FCells[x,y,z].FStone:=MakeStone(aliasst[t[x+1]],level);
        if FCells[x,y,z].FStone <> nil then begin
         FCells[x,y,z].FStone.x:=x;
         FCells[x,y,z].FStone.y:=y;
         FCells[x,y,z].FStone.z:=z;
        end;
       end;
      end;
     end;
    end
    else raise Exception.Create('[load] can''t load a zero-sized level');
   end;
   if t='itmap' then begin
    if (FX>0)and(FY>0)and(FZ>0) then begin
     for y:=0 to FY-1 do begin
      for z:=0 to FZ-1 do begin
       t:=GetToken(s,2+y*FZ+z,' ');
       for x:=0 to FX-1 do begin
        if FCells[x,y,z]=nil then
         FCells[x,y,z]:=TCell.Create('nil','nil',TLevel(level));
        FCells[x,y,z].FItem:=MakeItem(aliasit[t[x+1]],level);
        if FCells[x,y,z].FItem <> nil then begin
         FCells[x,y,z].FItem.x:=x;
         FCells[x,y,z].FItem.y:=y;
         FCells[x,y,z].FItem.z:=z;
        end;
       end;
      end;
     end;
    end
    else raise Exception.Create('[load] can''t load a zero-sized level');
   end;
 end;
 CloseFile(f);
 end;
end;

procedure UnLoadLevel();
begin

end;

procedure SaveLevel(args:String; level:pointer);
var lev:TLevel;
    f:TextFile;
    aliasst,aliasit:TAliasList;
    x,y,z,c:integer;
    cell:TCell;
    actor:TActor;
    mapit,mapst:array of array of array of char;
    t:string;

function getObjectCSV(source:TGameObject):string;
begin
 Result:='';
 case source.objectType of
  otStone: Result:=Result+'st,';
  otItem: Result:=Result+'it,';
  else begin
   TOzoneMainClass(lev.owner).O3Log.LogWarning('WARNING: UNSUPPORTED SIGNAL TYPE','import_ozone: saveLevel');
   Result:='';
   EXIT;
  end;
 end;
 Result:=Result+IntToStr(TO3LevObject(source).x)+','+IntToStr(TO3LevObject(source).y)+','+IntToStr(TO3LevObject(source).z);
end;

begin
 lev:=TLevel(level);
 setLength(mapit,lev.FX,lev.FY,lev.FZ);
 setLength(mapst,lev.FX,lev.FY,lev.FZ);
 aliasst:=TAliasList.Create;
 aliasit:=TAliasList.Create;
 for x:=0 to lev.FX-1 do
  for y:=0 to lev.FY-1 do
   for z:=0 to lev.FZ-1 do begin
    cell:=lev.getCell(x,y,z);
    if(cell=nil) then CONTINUE;
    if(cell.FStone<>nil) then begin
     if(aliasst.get(cell.FStone.info['cmd'])=#0) then
      mapst[x,y,z]:=aliasst.add(cell.FStone.info['cmd'])
     else
      mapst[x,y,z]:=aliasst.get(cell.FStone.info['cmd']);
    end
    else begin
     if(aliasst.get('nil')=#0) then
      mapst[x,y,z]:=aliasst.add('nil')
     else
      mapst[x,y,z]:=aliasst.get('nil');
    end;
    if(cell.FItem<>nil) then begin
     if(aliasit.get(cell.FItem.info['cmd'])=#0) then
      mapit[x,y,z]:=aliasit.add(cell.FItem.info['cmd'])
     else
      mapit[x,y,z]:=aliasit.get(cell.FItem.info['cmd']);
    end
    else begin
     if(aliasit.get('nil')=#0) then
      mapit[x,y,z]:=aliasit.add('nil')
     else
      mapit[x,y,z]:=aliasit.get('nil');
    end;
   end;
 AssignFile(f,getToken(args,1,','));
 ReWrite(f);
 if aliasit.fList.Count>0 then
  for c:=0 to aliasit.fList.Count-1 do
   WriteLn(f,'aliasit '+PAlias(aliasit.fList[c]).c+' '+PAlias(aliasit.fList[c]).a);
 if aliasst.fList.Count>0 then
  for c:=0 to aliasst.fList.Count-1 do
   WriteLn(f,'aliasst '+PAlias(aliasst.fList[c]).c+' '+PAlias(aliasst.fList[c]).a);

 Write(f,'xsize ');
 Writeln(f,lev.FX);
 Write(f,'ysize ');
 Writeln(f,lev.FY);
 Write(f,'zsize ');
 Writeln(f,lev.FZ);

 Write(f,'stmap');
 for y:=0 to lev.FY-1 do begin
  for z:=0 to lev.FZ-1 do begin
   Write(f,' ');
   for x:=0 to lev.FX-1 do begin
    Write(f,mapst[x,y,z]);
   end;
  end;
 end;
 Writeln(f,'');

 Write(f,'itmap');
 for y:=0 to lev.FY-1 do begin
  for z:=0 to lev.FZ-1 do begin
   Write(f,' ');
   for x:=0 to lev.FX-1 do begin
    Write(f,mapit[x,y,z]);
   end;
  end;
 end;
 Writeln(f,'');

 if lev.FActors.List.Count>0 then begin
  for c:=0 to lev.FActors.List.Count-1 do begin
   actor:=lev.FActors.List[c];
   Write(f,'actor ');
   Write(f,actor.Info['type']);
   Write(f,' ');
   Write(f,actor.x:4:2);
   Write(f,' ');
   Write(f,actor.y:4:2);
   Write(f,' ');
   Write(f,actor.z:4:2);
   Write(f,' ');
   Write(f,actor.Info['control']);
   Write(f,' ');
   if actor.name<>'' then Write(f,actor.name)
   else begin
    Write(f,'actor');
    Write(f,c);
   end;
   Write(f,' ');
   if actor.Info['cmd']<>'' then Writeln(f,actor.Info['cmd'])
   else Writeln(f,'nil');
  end;
 end;
 if lev.signals.FList.Count>0 then begin
  for c:=0 to lev.signals.FList.Count-1 do begin
   with TSignal(lev.signals.FList[c]) do begin
    t:='signal '+getObjectCSV(source)+' ';
    if(t='signal ') then CONTINUE;
    if targets.count>0 then
     for x:=0 to Targets.count-1 do begin
      writeln(f,t+getObjectCSV(TGameObject(Targets[x])));
     end;
   end;
  end;
 end;
 
 CloseFile(f);
 aliasst.Free;
 aliasit.Free;
end;

exports LoadLevel,
        UnLoadLevel,
        SaveLevel;

begin
end.
