library actor_horse;

uses
 {$IFDEF WIN32}
  ShareMem,
 {$ENDIF}
  dglOpenGL,
  o3vectors,
  SysUtils,
  Classes,
  o3actors,
  o3utils,
  o3world,
  ac3d,
  odeimport,
  o3control,
  o3stones,
  o3game,
  o3item,
  o3physics,
  o3m;

type
  TTarget = record
   x:single;
   z:single;
   wait:single;
   touched:boolean;
   w:single;
  end;
  THorseControl = class(To3Control)
   function Steer(ac:pointer;ti:integer):TVector3d; override;
  end;
  PTarget = ^TTarget;
  THorse = class(TActor)
   frame:single;
   return:boolean;
   targets:TList;
   force:single;
   procedure CreateBodyAndGeom(c:string;var g:TGeomList;var b:PdxBody); override;
   procedure Render(timeDelta:integer); override;
   destructor Destroy; override;
   constructor Create(name:string;sx,sy,sz:Single;control:TO3Control;Own:Pointer;i:string;coll:string); override;
   procedure processParameterList(p:TParameterList); override;
   function getParameterList():TParameterList; override;
  end;

  var ozone:TOzoneMainClass;
      p:string;
      Graph:TO3mFile;
{$LIBPREFIX 'lib'}

 procedure THorse.processParameterList(p:TParameterList);

 function check(s:string):boolean;
 var i:integer;
 begin
  Result:=false;
  if(s='') then EXIT;
  for i:=1 to Length(s) do
   if(not(s[i] in ['0','1','2','3','4','5','6','7','8','9','.']))then EXIT;
  Result:=true;
 end;
 
 var s:string;
  function getTargets:string;
  var x,z,w:string;
      i:integer;
  begin
   Result:='';
   if p[0].stringValue='' then EXIT;
   s:=p[0].stringValue;
   i:=1;
   while(s[i]<>'x') do begin inc(i); if(i>Length(s)) then EXIT; end;
   inc(i);

   while i<=Length(s) do begin
    x:='';
    z:='';
    w:='';
    if(i>Length(s)) then CONTINUE;
    while(s[i]<>'z') do begin
     x:=x+s[i];
     inc(i);
     if(i>Length(s)) then BREAK;
    end;
    inc(i);
    if(i>Length(s)) then CONTINUE;
    while(s[i]<>'w') do begin
     z:=z+s[i];
     inc(i);
     if(i>Length(s)) then BREAK;
    end;
    inc(i);
    if(i>Length(s)) then CONTINUE;
    while(s[i]<>'x') do begin
     w:=w+s[i];
     inc(i);
     if(i>Length(s)) then BREAK;
    end;
    inc(i);
    x:=trim(x);
    z:=trim(z);
    w:=trim(w);
    if(check(x))and(check(z))and(check(w)) then
     Result:=Result+'$T'+x+','+z+','+w;
   end;
  end;
 begin
  DecimalSeparator:='.';
  if p[1].boolValue then s:='1'
  else s:='0';
  info['cmd']:='Oreturn=1'+getTargets+'$Oforce='+floatToStr(p[2].floatValue);
  starty:=p[3].heightValue;
 end;
 
 function THorse.getParameterList:TParameterList;
 var t:TObjParameter;

 function getTargets:string;
 var x:integer;
 begin
  Result:='';
  if targets.count<=0 then exit;
  for x:=0 to targets.count-1 do begin
   result:=result+'x'+floatToStr(PTarget(targets[x]).x)+'z'+floatToStr(PTarget(targets[x]).z)+'w'+floatToStr(PTarget(targets[x]).wait)+' ';
  end;
  if result<>'' then
   Result:=Copy(Result,1,Length(Result)-1);
 end;
 
 begin

  Result:=TParameterList.Create;


  t:=TObjParameter.Create;
  t.stringValue:=getTargets;
  t.desc:='Targets, format: xXzZwWait';
  Result.Add(t);

  t:=TObjParameter.Create;
  t.boolValue:=return;
  t.desc:='Loop';
  Result.Add(t);

  t:=TObjParameter.Create;
  t.floatValue:=force;
  t.desc:='Force';
  Result.Add(t);

  t:=TObjParameter.Create;
  t.heightValue:=starty;
  t.desc:='Height';
  Result.Add(t);
 end;

 function THorseControl.Steer;
 var t:TVector3d;
 begin
  Result[0]:=0;
  Result[1]:=0;
  Result[2]:=0;
  if ac=nil then exit;
  with THorse(ac) do begin
   if targets.Count<=0 then exit;
   if targets.First<>nil then begin
    with PTarget(targets.First)^ do begin
     if touched then
      w:=w+ti/1000;
     if w>wait then begin
      touched:=false;
      w:=0;
      if return then
       targets.Move(targets.indexOf(targets.first),targets.indexOf(targets.last))
      else if targets.Count>1 then begin
       Dispose(targets.First);
       targets.Delete(0);
      end;
     end;
    end;
    if targets.First=nil then exit;
    t[0]:=(x-PTarget(targets.first).x);
    t[1]:=0;
    t[2]:=(z-PTarget(targets.first).z);
    Result:=mul(Norm(t),-25);
    if len(t,1,1,1)<1 then
     PTarget(targets.first).touched:=true;
   end;
  end;
 end;

 constructor THorse.Create;
 var s,t,u,v:string;
     x:integer;
     c:char;
     d:PTarget;
 begin
  DecimalSeparator:='.';
  return:=false;
  force:=1;
  targets:=TList.Create;
  x:=1;
  s:=GetToken(i,x,'$');
  while s<>'' do begin
   c:=s[1];
   s:=Copy(s,2,Length(s));
   case c of
    'T':begin
         t:=GetToken(s,1,',');
         u:=GetToken(s,2,',');
         v:=GetToken(s,3,',');
         if (t<>'')and(u<>'')and(v<>'') then begin
          new(d);
          with d^ do begin
           x:=StrToFloat(t);
           z:=StrToFloat(u);
           wait:=StrToFloat(v);
           touched:=false;
           w:=0;
          end;
          targets.Add(d);
         end;
        end;
    'O':begin
         t:=GetToken(s,1,'=');
         u:=GetToken(s,2,'=');
         if (t='return')and(u='1') then return:=true;
         if (t='force')and(u<>'') then
          force:=StrToFloat(u);
        end;
   end;
   inc(x);
   s:=GetToken(i,x,'$');
  end;
  physics.mass:=2;
  inherited Create(name,sx,sy,sz,control,Own,i,'');
  gfxtype:=o3utils.ozone;
  gfx:=graph;
  physics.steerPower:=force;
  physics.selfFric:=0;
  physics.floorSteerPower:=1;
  shadow:=ozone.shadowLib['sh-horse'];
 end;

 destructor THorse.Destroy;
 var x:integer;
 begin
  if targets.Count>0 then
   for x:=0 to targets.Count-1 do
    if targets[x]<>nil then
     Dispose(targets[x]);
  targets.Free;
  Dispose(body.BaseObject.userdata);
  inherited;
 end;

 procedure THorse.CreateBodyAndGeom;
 var m:TdMass;
     a:PdxGeom;
//     p:pptrInfo;
     t:PODEBodyData;
 begin
   dMassSetSphere(m,1,1);
   dMassAdjust(m,physics.mass);
   dBodySetMass(body,@m);
   dBodySetPosition(body,x,y,z);
//   a:=dCreateSphere(TLevel(owner).Physics.theSpace,0.5);
   a:=dCreateTriMesh(TLevel(owner).Physics.theSpace,
                               GetTriMeshFromO3m(graph,owner),
                               nil,
                               nil,
                               nil);
   odeimport.dGeomTriMeshEnableTC(a,odeimport.dTriMeshClass,1);
   odeimport.dGeomTriMeshClearTCCache(a);
   dGeomSetBody(a,body);
  // new(p);
//   p^.info:='actor';
//   p^.P:=self;
   dGeomSetData(a,self);
   dGeomSetPosition(a,x,y,z);
   geoms.add(a);
   t:=NewODEBodyData;
   t.stabilize:=true;
   t.fix[1]:=starty+0.3;
//   t.maxSpeedSquare:=0.7;
   t.maxSpeedSquare:=3.5;
   bounceity:=0.75;
   dBodySetData(body,t);
 end;

 procedure InitLib(path:string;owner:Pointer);
 begin
  DecimalSeparator:='.';
  p:=path;
  ozone:=owner;
  Graph:=TO3mFile.Create(ozone);
  Graph.LoadFromFile(p+'ac-horse.o3m');
 end;

 procedure QuitLib;
 begin
  Graph.free;
 end;

 function MakeActor(s:string;sx,sy,sz:Single;control:TO3Control;Own:Pointer;i:string):TActor;
 begin
  Result:=THorse.Create(s,sx,sy,sz,control,own,i,'');
 end;

 procedure THorse.Render;
 begin
  if controlProc=nil then
     controlProc:=THorseControl.Create;
  if OutOfGame then
   OutOfGame:=false;
  if not Alive then
   Alive:=true;
  frame:=frame+timeDelta/1000;
  TO3mFile(gfx).FObject.Kids[1].Rotate[1]:=frame*90;
  if frame>=4 then frame:=frame-4;
//  if visible then
   inherited Render(timeDelta);//ozone.gfxSys.DrawModel(gfx,x,y,z,o3utils.ozone,gfxinfo);
 end;


 exports MakeActor,
         InitLib,
         QuitLib;

begin
end.
