unit o3actorinterface;

interface
uses o3specialinterface,
     o3actors,
     Classes,
     o3utils,
     SysUtils,
     o3control
     {$IFDEF WIN32},Windows{$ENDIF},
     o3fpcloader;
       type
        TMakeActorFunc = function(s:string;sx,sy,sz:Single;control:TO3Control;Own:Pointer;i:string):TActor;
        TSpecialActorLibrary = class(TSpecialLib)
         public
          MakeActor:TMakeActorFunc;
          constructor Create(name:string;owner:pointer); override;
        end;
        TSpecialActorAlias = record
         Lib:TSpecialActorLibrary;
         name:string;
        end;
        TSpecialActorName = record
         Lib:string;
         name:string;
        end;
        PSpecialActorAlias = ^TSpecialActorAlias;
        PSpecialActorName = ^TSpecialActorName;
        TSpecialActorList = class
         private
          FList:TList;
          LList:TList;
          owner:pointer;
          function getObject(s:string):TSpecialActorLibrary;
          function getLib(s:string):TSpecialActorLibrary;
         public
          procedure addObject(name,libname:string);
          property Alias[s:string]:TSpecialActorLibrary read getObject; default;
          property Lib[s:string]:TSpecialActorLibrary read getLib;
          constructor create(filename:string;own:pointer);
          destructor destroy; override;
        end;
implementation
uses o3game;
 function TSpecialActorList.getObject;
 var x:integer;
 begin
  Result:=nil;
  if FList.Count>0 then begin
   for x:=0 to FList.Count-1 do begin
    if (FList.Items[x]<>nil)and(PSpecialActorName(FList.Items[x])^.name=s) then
     Result:=Lib[PSpecialActorName(FList.Items[x])^.Lib];
   end;
  end;
 end;

 function TSpecialActorList.getLib;
 var x:integer;
 begin
  Result:=nil;
  if LList.Count>0 then begin
   for x:=0 to LList.Count-1 do begin
    if (LList.Items[x]<>nil)and(PSpecialActorAlias(LList.Items[x])^.name=s) then Result:=PSpecialActorAlias(LList.Items[x])^.Lib;
   end;
  end
 end;

 procedure TSpecialActorList.addObject;
 var f:PSpecialActorAlias;
     e:PSpecialActorName;
 begin
  New(e);
  e^.name:=name;
  e^.Lib:=libname;
  if Lib[libname]=nil then begin
   New(f);
   f^.name:=libname;
   f^.Lib:=TSpecialActorLibrary.Create(TOzoneMainClass(owner).path+ModelSubDir+libname+LibExt,owner);
   LList.Add(f);
  end;
  FList.Add(e);
 end;

 constructor TSpecialActorList.create;
 var F:TextFile;
     s,n,fn:string;
 begin
  owner:=own;
  inherited Create;
  DecimalSeparator:='.';
  FList:=TList.Create;
  LList:=TList.Create;
  AssignFile(F,filename);
  Reset(F);
  while(not Eof(F)) do begin
   ReadLn(F,s);
   n:=GetToken(s,1,' ');
   fn:=GetToken(s,2,' ');
   TOzoneMainClass(own).gfxSys.writeProgress('loading '+fn);
   addObject(n,fn);
  end;
  CloseFile(F);
 end;

 destructor TSpecialActorList.destroy;
 var x:integer;
 begin
  if FList.Count>0 then
   for x:=0 to FList.Count-1 do begin
    if FList.Items[x]<>nil then begin
     Dispose(FList.Items[x]);
    end;
   end;
  FList.Free;
  if LList.Count>0 then
   for x:=0 to LList.Count-1 do begin
    if LList.Items[x]<>nil then begin
     if PSpecialActorAlias(LList.Items[x])^.Lib<>nil then
      PSpecialActorAlias(LList.Items[x])^.Lib.Free;
     Dispose(LList.Items[x]);
    end;
   end;
  LList.Free;
  inherited;
 end;

 constructor TSpecialActorLibrary.Create;
 begin
   inherited;
  if Self<>nil then
    @MakeActor:=GetProcAddress(FHandle,'MakeActor');
 end;

end.
