
unit o3basicobj;

interface
uses ac3d,
     o3utils,
     odeimport,
     SysUtils,
     dglOpenGL;
type
        TO3LevObject = class;
//        TObjType = (stone,item);
        TO3LevObject = class(TGameObject)
         public
          fx,fy,fz:integer;
          //t:TObjType;
          body:PdxBody;
          geoms:TGeomList;
          shadow:integer;
          procedure setX(const val:integer); virtual;
          procedure setY(const val:integer); virtual;
          procedure setZ(const val:integer); virtual;
          property x:integer read fx write setX;
          property y:integer read fy write setY;
          property z:integer read fz write setZ;
//          procedure Render(timeDelta:integer); virtual;
          constructor Create(name:string;cInfo:string;own:Pointer); reintroduce; virtual;
          destructor Destroy; override;
          procedure CreateBodyAndGeom(c:string;var g:TGeomList;var b:PdxBody); virtual;
          procedure UpdateGeomPos; virtual;
          procedure playSound(reason:string;data:array of pointer); virtual;
        end;
        PO3LevObject =^TO3LevObject;
implementation
uses o3objects,
     o3world,
     o3game;

 procedure TO3LevObject.playSound;
 var c:^Single;
     vol:integer;
 begin
  if reason='collision' then begin
   c:=data[0];
   vol:=round(c^*25);
   if vol>100 then vol:=100;
   TOzoneMainClass(TLevel(owner).owner).soundLib.playSound('stdcollision',cx,cy,cz,vol);
  end;
 end;

 procedure TO3LevObject.UpdateGeomPos;
 begin
  if info['collision']='nogeom' then exit;
  if (geoms<>nil) and (geoms[0]<>nil) then begin
   if info['collision']='hole' then
    odeimport.dGeomSetPosition(geoms[0],fx+0.5,fy+0.9,fz+0.5)
   else if info['collision']='model' then
    odeimport.dGeomSetPosition(geoms[0],fx,fy,fz)
   else odeimport.dGeomSetPosition(geoms[0],fx+0.5,fy+0.5,fz+0.5);
  end;
 end;

 procedure TO3LevObject.setX;
 begin
  fx:=val;
  cx:=fx+0.5;
  UpdateGeomPos;
 end;

 procedure TO3LevObject.setY;
 begin
  fy:=val;
  cy:=fy+0.5;
  UpdateGeomPos;
 end;

 procedure TO3LevObject.setZ;
 begin
  fz:=val;
  cz:=fz+0.5;
  UpdateGeomPos;
 end;


 procedure TO3LevObject.CreateBodyAndGeom;
 var a:PdxGeom;
     //p:pptrInfo;
 begin
  DecimalSeparator:='.';
  info['collision']:=c;
  if c='nogeom' then Exit;
  if c='hole' then
   a:=dCreateBox(TLevel(owner).Physics.theSpace,1,0.1,1)
  else if (c='model') then begin
   if gfx=nil then
    if (info<>nil)and(owner<>nil) then begin
     gfx:=TOzoneMainClass(TLevel(owner).owner).Objects[info['name']];
     gfxtype:=TOzoneMainClass(TLevel(owner).owner).Objects.Raw[info['name']].actype;
    end;
   if gfx=nil then begin
    TOzoneMainClass(TLevel(owner).owner).O3Log.LogError('NO MODEL PRESENT! CAN''T GENARATE THE TriMesh!','TO3LevObject.CreateBodyAndGeom');
    EXIT;
   end;
   a:=nil;
   if gfxtype=ac then
    a:=dCreateTriMesh(TLevel(owner).Physics.theSpace,
                                GetTriMeshFromAC3d(gfx,owner),
                                nil,
                                nil,
                                nil);
   if gfxtype=ozone then
    a:=dCreateTriMesh(TLevel(owner).Physics.theSpace,
                                GetTriMeshFromO3m(gfx,owner),
                                nil,
                                nil,
                                nil);
   if a<>nil then begin
    odeimport.dGeomTriMeshEnableTC(a,odeimport.dTriMeshClass,1);
    odeimport.dGeomTriMeshClearTCCache(a);
   end
   else
     a:=dCreateBox(TLevel(owner).Physics.theSpace,1,1,1);
  end
  else
   a:=dCreateBox(TLevel(owner).Physics.theSpace,1,1,1);
 // odeimport.dCreate
//   new(p);
//   odeimport.dGeomTriMeshEnableTC(a,odeimport.dTriMeshClass,0);
//   p^.info:='object';
//   p^.P:=self;
   dGeomSetData(a,self);
   geoms.add(a);
 end;

// procedure TO3LevObject.Render;
// begin
 // if (gfx<>nil) and visible then
   //     TOzoneMainClass(TLevel(owner).owner).gfxSys.DrawModel(gfx,0,0,0,gfxtype,gfxinfo);

 //end;

 constructor TO3LevObject.Create;
 begin
  inherited Create;
//  visible:=true;
  Owner:=own;
  shadow:=0;
//  info := TInfoList.Create;
  info['name']:=GetToken(name,1,':');
  info['cmd']:=name;
//  body:=dBodyCreate(PLevel(own)^.Physics.theWorld);
  geoms:= TGeomList.Create;
  Info['collision']:=cInfo;
  if cInfo<>'nogeom' then begin
   CreateBodyAndGeom(cInfo,geoms,body);
   x:=-1;
   y:=-1;
   z:=-1;
  end;
 end;

 destructor TO3LevObject.Destroy;
 begin
  //info.Free;
  if body<>nil then dBodyDestroy(body);
  geoms.DeleteAllGeoms;
  geoms.Free;
  inherited Destroy;
 end;

end.
