unit o3interfaces;

interface
uses o3utils,
     classes;
type
     TO3Key=(
      O3K_BACKSPACE = 8, O3K_TAB = 9, O3K_CLEAR = 12, O3K_RETURN = 13, O3K_PAUSE = 19, O3K_ESCAPE = 27, O3K_SPACE = 32, O3K_EXCLAIM = 33, O3K_QUOTEDBL = 34, O3K_HASH = 35, O3K_DOLLAR = 36, O3K_AMPERSAND = 38,
      O3K_QUOTE = 39, O3K_LEFTPAREN = 40, O3K_RIGHTPAREN = 41, O3K_ASTERISK = 42, O3K_PLUS = 43, O3K_COMMA = 44, O3K_MINUS = 45, O3K_PERIOD = 46, O3K_SLASH = 47, O3K_0 = 48, O3K_1 = 49, O3K_2 = 50, O3K_3 = 51, O3K_4 = 52, O3K_5 = 53,
      O3K_6 = 54, O3K_7 = 55, O3K_8 = 56, O3K_9 = 57, O3K_COLON = 58, O3K_SEMICOLON = 59, O3K_LESS = 60, O3K_EQUALS = 61, O3K_GREATER = 62, O3K_QUESTION = 63, O3K_AT = 64, O3K_LEFTBRACKET = 91, O3K_BACKSLASH = 92, O3K_RIGHTBRACKET = 93,
      O3K_CARET = 94, O3K_UNDERSCORE = 95, O3K_BACKQUOTE = 96, O3K_a = 97, O3K_b = 98, O3K_c = 99, O3K_d = 100, O3K_e = 101, O3K_f = 102, O3K_g = 103, O3K_h = 104, O3K_i = 105, O3K_j = 106, O3K_k = 107, O3K_l = 108, O3K_m = 109,
      O3K_n = 110, O3K_o = 111, O3K_p = 112, O3K_q = 113, O3K_r = 114, O3K_s = 115, O3K_t = 116, O3K_u = 117, O3K_v = 118, O3K_w = 119, O3K_x = 120, O3K_y = 121, O3K_z = 122, O3K_DELETE = 127, O3K_KP0 = 256, O3K_KP1 = 257, O3K_KP2 = 258,
      O3K_KP3 = 259, O3K_KP4 = 260, O3K_KP5 = 261, O3K_KP6 = 262, O3K_KP7 = 263, O3K_KP8 = 264, O3K_KP9 = 265, O3K_KP_PERIOD = 266, O3K_KP_DIVIDE = 267, O3K_KP_MULTIPLY = 268, O3K_KP_MINUS = 269, O3K_KP_PLUS = 270, O3K_KP_ENTER = 271,
      O3K_KP_EQUALS = 272, O3K_UP = 273, O3K_DOWN = 274, O3K_RIGHT = 275, O3K_LEFT = 276, O3K_INSERT = 277, O3K_HOME = 278, O3K_END = 279, O3K_PAGEUP = 280, O3K_PAGEDOWN = 281, O3K_F1 = 282, O3K_F2 = 283, O3K_F3 = 284, O3K_F4 = 285,
      O3K_F5 = 286, O3K_F6 = 287, O3K_F7 = 288, O3K_F8 = 289, O3K_F9 = 290, O3K_F10 = 291, O3K_F11 = 292, O3K_F12 = 293, O3K_NUMLOCK = 300, O3K_CAPSLOCK = 301, O3K_SCROLLOCK = 302, O3K_RSHIFT = 303, O3K_LSHIFT = 304,
      O3K_RCTRL = 305, O3K_LCTRL = 306, O3K_RALT = 307, O3K_LALT = 308, O3K_RMETA = 309, O3K_LMETA = 310, O3K_LSUPER = 311, O3K_RSUPER = 312, O3K_ALTGR = 313, O3K_BREAK = 318, O3K_MENU = 319
     );
     TLookMode = record
      SwapXY:boolean;
      XS,YS:integer;
      LX,LY,LZ:integer;
      UX,UY,UZ:single;
     end;
     TO3SoundSystem = class
     public
      owner:pointer;
      procedure UpdateListener(posx,posy,posz:single;ox,oy,oz:single); virtual; abstract;
      constructor Create(own:pointer); virtual;
      function LoadSound(fname:string):Pointer; virtual; abstract;
      function PlaySound(t:Pointer;x,y,z,xv,yv,zv:single;volume:integer=100):pointer; virtual; abstract;
      procedure HaltSound(i:pointer); virtual; abstract;
      procedure FreeSound(p:pointer); virtual; abstract;
//      function PlaySoundLowPriority(t:Pointer;loops:integer;volume:integer=100):byte; virtual; abstract;
      function LoadMusic(fname:string):Pointer; virtual; abstract;
      procedure PlayMusic(t:Pointer;repeats:integer); virtual; abstract;
      procedure HaltMusic; virtual; abstract;
      procedure SetMusicVolume(volume:integer); virtual; abstract;
      procedure FreeMusic(p:pointer); virtual; abstract;
     end;
     TO3GfxSystem = class
     public
      owner:pointer;
      renderPass:integer;
      noswap:boolean; // do not swap display buffers (multipass rendering!). use swap();
      noclear:boolean; //do not clear display buffers (multipass rendering!). use clear();
      DrawShadow:boolean;
      constructor Create(own:pointer); virtual;
      function CreatePlaneXYModel(xs,ys:single;text:string;sDir:string):pointer; virtual; abstract;
      procedure FreePlaneXYModel(var model:pointer); virtual; abstract;
      procedure LoadTexture(var tex:Cardinal;text:string;subdir:string); virtual; abstract;
      procedure FreeTexture(var tex:Cardinal); virtual; abstract;
      procedure DrawText( tx, ty : single; Text : string; fontset : cardinal; s:single;r,g,b:single;reset:boolean=true ); virtual; abstract;
      procedure DrawModel(m:pointer;px,py,pz:single;mtype:TModelType;gfxinfo:PGfxInfo=nil;abscoord:boolean = false); virtual; abstract;
//      procedure HighlightModel(m:pointer;mtype:TModelType;r,b,g:single); virtual; abstract;
      procedure DoLevel(level:pointer); virtual; abstract;
      procedure DoMenu(menu:pointer); virtual; abstract;
      procedure MakeLevelEnd(level:pointer); virtual; abstract;
      procedure writeProgress(s:string); virtual; abstract;
      procedure translate(x,y,z:single); virtual; abstract;
      procedure rotate(ang,x,y,z:single); virtual; abstract;
      procedure lookAt(xc,yc,zc:single;xp,yp,zp:single;xu,yu,zu:single); virtual; abstract;
      procedure setLightPos(x,y,z,w:single); virtual; abstract;
      procedure viewport(x,y,xw,yw:single); virtual; abstract;
      procedure swap; virtual; abstract;
      procedure clear; virtual; abstract;
      procedure popmatrix; virtual; abstract;
      procedure pushmatrix; virtual; abstract;
      procedure loadIdentityMatrix; virtual; abstract;
      procedure setProjectionMatrix; virtual; abstract;
      procedure setViewMatrix; virtual; abstract;
      procedure setPerspective(fov,aspect,zNear,zFar:Single); virtual; abstract;
      procedure PaintLevel(lev:pointer;delta:integer;ex,ey,ez,cx,cy,cz:single;plane:integer=-1;grid:boolean=false); virtual; abstract;
      procedure PaintGrid; virtual; abstract;
      procedure enableLighting; virtual; abstract;
      procedure disableLighting; virtual; abstract;
      procedure setColor(r,g,b,a:single); virtual; abstract;
      procedure drawLine(x1,y1,z1,x2,y2,z2:single;w:integer); virtual; abstract;
      procedure disableDepthTest; virtual; abstract;
      procedure enableDepthTest; virtual; abstract;
     end;
     TO3InvSystem = class
     public
      owner:pointer;
      constructor create(own:pointer); virtual;
      procedure RenderInventary(time:integer;inventary:pointer); virtual; abstract;
      function NewInventary:pointer; virtual; abstract;
      procedure CreateItemGfx(gfx:string;var item:TItemTexInfo); virtual; abstract;
      procedure FreeItemGfx(var item:TItemTexInfo); virtual; abstract;
     end;
     TO3ParticleSystemGfx = class
     public
      owner:pointer;
      constructor create(own:pointer); virtual;
      function NewParticleSystem:pointer; virtual; abstract;
      procedure RenderParticleSystem(psys:pointer;deltaTime:integer); virtual; abstract;
     end;
     TO3InputListener = class
      procedure keyDown(key:TO3Key); virtual;
      procedure keyUp(key:TO3Key); virtual;
      procedure mouseDown(button:integer); virtual;
      procedure mouseUp(button:integer); virtual;
      procedure mouseMove(dx,dy:integer); virtual;
     end;
     TO3InputSystem = class
     public
      owner:pointer;
      listenerList:TList;
      constructor create(own:pointer); virtual;
      destructor Destroy; override;
      procedure Tick; virtual; abstract;
      procedure keyDown(key:TO3Key); virtual;
      procedure keyUp(key:TO3Key); virtual;
      procedure mouseDown(button:integer); virtual;
      procedure mouseUp(button:integer); virtual;
      procedure mouseMove(dx,dy:integer); virtual;
      procedure addListener(listener:TO3InputListener); virtual;
      procedure deleteListener(listener:TO3InputListener); virtual;
     end;
     TO3IOSystem = class
      owner:pointer;
      SoundSys:TO3SoundSystem;
      GfxSys:TO3GfxSystem;
      InvSys:TO3InvSystem;
      ParticleGfxSys:TO3ParticleSystemGfx;
      InputSystem:TO3InputSystem;
      function getTicks:cardinal; virtual; abstract;
      constructor Create(own:pointer;VidH,VidW,bpp:cardinal;fullscreen:boolean); virtual;
     end;
const
 LCount = 4;
 L : array[0..LCount-1] of TLookMode =
((SwapXY:True; XS:1; YS:-1; LX:6; LY:4; LZ:0; UX:0; UY:01; UZ:0),
 (SwapXY:False; XS:1; YS:1; LX:0; LY:4; LZ:6; UX:0; UY:01; UZ:0),
 (SwapXY:True; XS:-1; YS:1; LX:-6; LY:4; LZ:0; UX:0; UY:01; UZ:0),
 (SwapXY:False; XS:-1; YS:-1; LX:0; LY:4; LZ:-6; UX:0; UY:01; UZ:0));

 implementation

 procedure TO3InputListener.keyDown(key:TO3Key);
 begin
 end;
 procedure TO3InputListener.keyUp(key:TO3Key);
 begin
 end;
 procedure TO3InputListener.mouseDown(button:integer);
 begin
 end;
 procedure TO3InputListener.mouseUp(button:integer);
 begin
 end;
 procedure TO3InputListener.mouseMove(dx,dy:integer);
 begin
 end;

 constructor TO3SoundSystem.Create;
 begin
  owner:=own;
 end;
 constructor TO3GfxSystem.Create;
 begin
  owner:=own;
  noswap:=false;
  noclear:=false;
 end;
 constructor TO3InvSystem.create;
 begin
  owner:=own;
 end;
 constructor TO3ParticleSystemGfx.create;
 begin
  owner:=own;
 end;
 constructor TO3InputSystem.Create;
 begin
  owner:=own;
  listenerList:=TList.Create;
 end;

 procedure TO3InputSystem.addListener;
 begin
  listenerList.Add(listener);
 end;
 procedure TO3InputSystem.deleteListener;
 begin
  listenerList.Remove(listener);
 end;

 procedure TO3InputSystem.keyDown;
 var x:integer;
 begin
  if listenerList.Count<=0 then EXIT;
  for x:=0 to listenerList.Count-1 do
   if (x<listenerList.Count)and(listenerList[x]<>nil) then begin
    TO3InputListener(listenerList[x]).keyDown(key);
   end;
 end;

 procedure TO3InputSystem.keyUp;
 var x:integer;
 begin
  if listenerList.Count<=0 then EXIT;
  for x:=0 to listenerList.Count-1 do
   if (x<listenerList.Count)and(listenerList[x]<>nil) then begin
    TO3InputListener(listenerList[x]).keyUp(key);
   end;
 end;

 procedure TO3InputSystem.mouseDown;
 var x:integer;
 begin
  if listenerList.Count<=0 then EXIT;
  for x:=0 to listenerList.Count-1 do
   if (x<listenerList.Count)and(listenerList[x]<>nil) then begin
    TO3InputListener(listenerList[x]).mouseDown(button);
   end;
 end;

 procedure TO3InputSystem.mouseUp;
 var x:integer;
 begin
  if listenerList.Count<=0 then EXIT;
  for x:=0 to listenerList.Count-1 do
   if (x<listenerList.Count)and(listenerList[x]<>nil) then begin
    TO3InputListener(listenerList[x]).mouseUp(button);
   end;
 end;

 procedure TO3InputSystem.mouseMove;
 var x:integer;
 begin
  if listenerList.Count<=0 then EXIT;
  for x:=0 to listenerList.Count-1 do
   if (x<listenerList.Count)and(listenerList[x]<>nil) then begin
    TO3InputListener(listenerList[x]).mouseMove(dx,dy);
   end;
 end;

 destructor TO3InputSystem.destroy;
 begin
  listenerList.Free;
 end;
 constructor TO3IOSystem.Create;
 begin
  owner:=own;
 end;
end.
