unit o3inventary;

interface
uses Contnrs,
     o3opengl_font,
     o3utils,
     o3item,
     SysUtils,
     o3interfaces;
type TInvMode = (normal,scrolltext,statictext,inputtext);
     TInventary = class(TObjectList)
      public
       owner:TO3InvSystem;
       mode:TInvMode;
       staticTxt:string;
       scrollTxt:string;
       inputTxt:string;
       timeout:integer;
       stimeout:integer;
       constructor Create(o:TO3InvSystem);
       procedure Rotate;
       procedure Render(delta:integer);
       procedure StartStaticText(text:string;tout:cardinal);
       procedure StartScrollText(text:string;speed:cardinal);
       procedure AppendInputText(text:string;tout:cardinal);
       procedure DeleteInputText(tout:cardinal);
       function Add(i:TObject):integer;
     end;
     TFreeItemGfx = procedure (var item:TItemTexInfo);
     TCreateItemGfx = procedure (gfx:string;var item:TItemTexInfo);


implementation
uses o3game;
function TInventary.Add;
begin
 timeout:=0;
 stimeout:=0;
 Result:=inherited Add(i);
end;

constructor TInventary.Create;
begin
 inherited Create(false);
 owner:=o;
 timeout:=0;
 stimeout:=0;
 scrollTxt:='';
 staticTxt:='';
 inputTxt:='';
end;

procedure TInventary.Rotate;
begin
 timeout:=0;
 stimeout:=0;
 if count>0 then
  move(indexOf(first),indexOf(last));
 TOzoneMainClass(owner.owner).soundLib.playSound('inv_switch',TOzoneMainClass(owner.owner).theLevel.theActorToFollow.x,TOzoneMainClass(owner.owner).theLevel.theActorToFollow.y,TOzoneMainClass(owner.owner).theLevel.theActorToFollow.z);
end;

procedure TInventary.StartStaticText;
begin
 mode:=staticText;
 staticTxt:=text;
 timeout:=tout;
 stimeout:=tout;
end;

procedure TInventary.AppendInputText;
begin
 mode:=inputText;
 inputTxt:=text;
 timeout:=tout;
 stimeout:=tout;
end;

procedure TInventary.DeleteInputText;
begin
 mode:=inputText;
 inputTxt:='';
 timeout:=tout;
 stimeout:=tout;
end;



procedure TInventary.StartScrollText;
begin
 mode:=scrollText;
 scrollTxt:=text;
 if speed=0 then
  speed:=1;
 timeout:=round(1000*(Length(scrollTxt)/speed));
 stimeout:=timeout;
end;

procedure TInventary.Render;
begin
 owner.RenderInventary(delta,self);
end;

end.
