unit o3inventary_sdlogl;

interface
uses SDL,dglOpenGL,
     o3interfaces,
     o3utils;
type
 TO3InvSystem_SDLOGL = class(TO3InvSystem)
  gfx:TO3GfxSystem;
  invTex:Cardinal;
  invDList:Cardinal;
  SCREEN_WIDTH,SCREEN_HEIGHT:integer;
  constructor create(own:pointer); override;
  procedure RenderInventary(delta:integer;inventary:pointer); override;
  function NewInventary:pointer; override;
  procedure CreateItemGfx(gfxI:string;var item:TItemTexInfo); override;
  procedure FreeItemGfx(var item:TItemTexInfo); override;
  destructor Destroy; override;
 end;
const sm = 384;
implementation
 uses o3game,o3inventary,o3item;
 procedure TO3InvSystem_SDLOGL.CreateItemGfx;
 begin
  gfx.LoadTexture(item.invTex,gfxI,ItemTexSubDir);
  glEnable(GL_TEXTURE_2D);
  item.invList := glGenLists(1);
  glBindTexture( GL_TEXTURE_2D, item.invTex );
  glNewList(item.invList,GL_COMPILE);
  glBegin( GL_QUADS );
   glTexCoord2f(0, 0);
   glVertex2f(0, 64/sm);
   glTexCoord2f(1, 0);
   glVertex2f(64/sm, 64/sm);
   glTexCoord2f(1, 1);
   glVertex2f(64/sm, 0);
   glTexCoord2f(0, 1);
   glVertex2f(0, 0);
  glEnd;
  glEndList;
  glDisable(GL_TEXTURE_2D);
 end;

 procedure TO3InvSystem_SDLOGL.FreeItemGfx;
 begin
  gfx.FreeTexture(item.invTex);
  glDeleteLists(item.invList,1);
 end;

 constructor TO3InvSystem_SDLOGL.create;
 begin
  inherited;
  gfx:=TOzoneMainClass(owner).gfxSys;
  SCREEN_WIDTH:=TOzoneMainClass(owner).VidW;
  SCREEN_HEIGHT:=TOzoneMainClass(owner).VidH;
  glEnable(GL_TEXTURE_2D);
  gfx.LoadTexture(invTex,'inv.png',BitmapSubDir);
  invDList := glGenLists(1);
  glBindTexture( GL_TEXTURE_2D, invTex );
  glNewList(invDList,GL_COMPILE);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  glBegin( GL_QUADS );
   glTexCoord2f(0, 0);
   glVertex2f(0, 96/sm);
   glTexCoord2f(1, 0);
   glVertex2f(1024/sm, 96/sm);
   glTexCoord2f(1, 1);
   glVertex2f(1024/sm, 0);
   glTexCoord2f(0, 1);
   glVertex2f(0, 0);
  glEnd;
  glEndList;
  glDisable(GL_TEXTURE_2D);
 end;
 destructor TO3InvSystem_SDLOGL.Destroy;
 begin
  gfx.FreeTexture(invTex);
  glDeleteLists(invDList,1);
 end;
 function TO3InvSystem_SDLOGL.NewInventary;
 begin
  Result:=TInventary.Create(self);
 end;
 procedure TO3InvSystem_SDLOGL.RenderInventary;
 const firstx = 300;
       firsty = 16;
       size = 52;
 var x:integer;
     pxm:single;
     oz:TOzoneMainClass;
 begin
 oz:=owner;
 with TInventary(inventary) do begin
  if timeOut>0 then
   if (timeout-delta)<0 then timeout:=0
   else dec(timeout,delta);
  if timeout<=0 then
   mode:=normal;
   glMatrixMode(GL_PROJECTION);
   glPushMatrix;
   glLoadIdentity;
   glOrtho(-1.33,1.33,-1/oz.vsplit,1/oz.vsplit,5,-5);
//   glOrtho(-1.33,1.33,-1,1,5,-5);
   glMatrixMode(GL_MODELVIEW);
   glPushMatrix;
   glLoadIdentity;
   glColor3f( 1,1,1 );
   glDisable(GL_CULL_FACE);
   glEnable( GL_TEXTURE_2D );
   glBindTexture( GL_TEXTURE_2D, invTex );
   glDisable( GL_DEPTH_TEST );
   glDisable(GL_LIGHTING);
   glTranslated( -1.33,-1/oz.vsplit, 0 );
   glCallList(invDList);
   case mode of
    normal:
    begin
      if Count>0 then begin
      glTranslated(firstx/sm,0.1-firsty/sm,0);
      for x:=0 to Count-1 do begin
       glBindTexture(GL_TEXTURE_2D,TItem(Items[x]).gettexinfo.invTex);
       glScalef(0.75,0.75,1);
       glCallList(TItem(Items[x]).gettexinfo.invList);
       glScalef(1.333333,1.3333335,1);
       glTranslated(size/sm,0,0);
      end;
     end;
    end; // mode=normal
    statictext:begin
      glTranslated(firstx/sm,0.12-firsty/sm,0);
      gfx.DrawText(0,0,staticTxt,0,1,1,1,1,false);
    end;
    inputtext:begin
      glTranslated(firstx/sm,0.12-firsty/sm,0);
      gfx.DrawText(0,0,inputTxt,0,1,1,1,1,false);
    end;
    scrolltext:begin
      pxm:=1024/SCREEN_WIDTH;
      glViewport(trunc(firstX/pxm),trunc(firstY/pxm),trunc(13*size/pxm),trunc((13*SCREEN_HEIGHT*size)/(pxm*SCREEN_WIDTH)));
      glTranslated((firstx/sm)+(13*size/sm)-(((Length(scrollTxt)*16*0.009)+(13*size/sm))/(stimeout/1000))*((stimeout-timeout)/1000),0.12-firsty/sm,0);
      gfx.DrawText(0,0,scrollTxt,0,1.5,1,1,1,false);
      glViewport(0,0,SCREEN_WIDTH,SCREEN_HEIGHT);
    end;
   end;
   glDisable( GL_TEXTURE_2D );
   glEnable( GL_DEPTH_TEST );
   glEnable(GL_LIGHTING);
   glPopMatrix;
   glMatrixMode(GL_PROJECTION);
   glPopMatrix;
   glMatrixMode(GL_MODELVIEW);   
  end;
 end;
end.
