
unit o3levelmenu;

interface
uses o3menu,
     SysUtils;
type
 TLevPackLevel = record
   t:string;
   filename:string;
   loader:string;
   args:string;
   metaTITLE:string;
   metaDESCRIPTION:string;
   metaLOADED:boolean;
  end;
  TO3LevelMenu = class(TO3Menu)
   levels:array of TLevPackLevel;
   lpRel:string;
   ozone:pointer;
   cLevel:integer;
   procedure OnDestroy; override;
   constructor createFromLevelpack(levelpack:string;o3_state:pointer);
   procedure setView(offset:integer);
   procedure slevel(sender:TO3Control);
   procedure emenu(sender:TO3Control);
   procedure nlevel(sender:TO3Control);
   procedure plevel(sender:TO3Control);
  end;
implementation
uses o3game,o3utils,o3interfaces;

procedure TO3LevelMenu.nlevel(sender:TO3Control);
begin
 setView(((cLevel+1)mod Length(levels)));
end;

procedure TO3LevelMenu.plevel(sender:TO3Control);
begin
 setView(((cLevel+Length(levels)-1)mod Length(levels)));
end;

procedure TO3LevelMenu.slevel;
begin
 active:=false;
 cLevel:=TOzoneMainClass(ozone).StartLevelPack(lpRel,cLevel);
 setView(cLevel);
 active:=true;
end;

procedure TO3LevelMenu.emenu;
begin
// KeyDown(O3K_ESCAPE);
// TOzoneMainClass(ozone).StartLevelPack(lpRel,cLevel-1);
 exitMenu:=true;
end;

procedure TO3LevelMenu.setView;
var tButton:TO3CustomButton;
    i:TextFile;
begin
  cLevel:=offset;
  tButton:=TO3CustomButton(FindControl('preview'));
  if tButton.bgModel<>nil then
    TOzoneMainClass(ozone).gfxSys.FreePlaneXYModel(tbutton.bgModel);
  if FileExists(TOzoneMainClass(ozone).path+lpRel+MetaSubDir+levels[offset].filename+'.png') then
   tButton.bgModel:=TOzoneMainClass(ozone).gfxSys.CreatePlaneXYModel(1.33,1,levels[offset].filename+'.png',lpRel+MetaSubDir)
  else
   tButton.bgModel:=TOzoneMainClass(ozone).gfxSys.CreatePlaneXYModel(1.33,1,'nopreview.png',BitmapSubDir);
  tButton.bgMType:=plane;
  if not levels[cLevel].metaLOADED then begin
   levels[cLevel].metaLoaded:=true;
   if FileExists(TOzoneMainClass(ozone).path+lpRel+MetaSubDir+levels[offset].filename+'.info') then begin
    Assign(i,TOzoneMainClass(ozone).path+lpRel+MetaSubDir+levels[offset].filename+'.info');
    Reset(i);
    if not eof(i) then ReadLn(i,levels[cLevel].metaTITLE);
    if not eof(i) then ReadLn(i,levels[cLevel].metaDESCRIPTION);
    Close(i);
   end;
  end;
  tButton:=TO3CustomButton(FindControl('title'));
  tButton.Text:=levels[cLevel].metaTITLE;
  tButton:=TO3CustomButton(FindControl('desc'));
  tButton.Text:=levels[cLevel].metaDESCRIPTION;

end;

procedure TO3LevelMenu.onDestroy;
begin
 SetLength(levels,0);
 inherited;
end;

constructor TO3LevelMenu.createFromLevelpack;
var x:integer;
    Inp:TextFile;
    s:string;
    tButton:TO3CustomButton;
begin
 inherited Create(o3_state);
 ozone:=o3_state;
 showToolTips:=false;
 SetLength(levels,0);
 lpRel:=levelpack;
 Assign(Inp,TOzoneMainClass(ozone).path+PathDelim+levelpack+'index');
 Reset(Inp);
 x:=1;
 while not Eof(Inp) do begin
  ReadLn(Inp,s);
  if (s<>'')and(s[1]<>';') then begin
   SetLength(levels,x);
   levels[x-1].t:=GetToken(s,1,':');
   levels[x-1].loader:=GetToken(s,2,':');
   levels[x-1].filename:=GetToken(s,3,':');
   levels[x-1].args:=GetToken(s,4,':');
   levels[x-1].metaLOADED:=false;
   levels[x-1].metaTITLE:='Another nameless level ('+inttostr(x)+')';
   levels[x-1].metaDESCRIPTION:='This level has no name nor description!';
   inc(x);
  end;
 end;
 Close(Inp);
 TButton:=TO3CustomButton.Create(TOzoneMainClass(ozone).gfxSys,'preview');
 TButton.bgMtype:=plane;
 TButton.x:=-0.5;
 TButton.y:=0.3;
 TButton.w:=2.66;
 TButton.h:=1;
// TButton.WordWarp:=true;
 TButton.ToolTip:='';
 AddControl(TButton);

 TButton:=TO3CustomButton.Create(TOzoneMainClass(ozone).gfxSys,'start');
 TButton.BgModel:=TOzoneMainClass(ozone).gfxSys.CreatePlaneXYModel(0.6,0.6,'button_levstart.png',BitmapSubDir);
 TButton.bgMtype:=plane;
 TButton.x:=-0.5;
 TButton.y:=-0.5;
 TButton.w:=0.6;
 TButton.h:=0.6;
 TButton.ToolTip:='';
 TButton.OnClick:=slevel;
 AddControl(TButton);

 TButton:=TO3CustomButton.Create(TOzoneMainClass(ozone).gfxSys,'exit');
 TButton.BgModel:=TOzoneMainClass(ozone).gfxSys.CreatePlaneXYModel(0.5,0.5,'button_exit.png',BitmapSubDir);
 TButton.bgMtype:=plane;
 TButton.x:=1;
 TButton.y:=-0.7;
 TButton.w:=0.5;
 TButton.h:=0.5;
 TButton.ToolTip:='';
 TButton.OnClick:=emenu;
 AddControl(TButton);

 TButton:=TO3CustomButton.Create(TOzoneMainClass(ozone).gfxSys,'title');
 TButton.BgModel:=nil;
 TButton.bgMtype:=plane;
 TButton.x:=0.0;
 TButton.y:=0.85;
 TButton.w:=1;
 TButton.h:=0.5;
 TButton.ToolTip:='';
 TButton.Text:='';
// TButton.OnClick:=emenu;
 AddControl(TButton);

 TButton:=TO3CustomButton.Create(TOzoneMainClass(ozone).gfxSys,'desc');
 TButton.BgModel:=nil;
 TButton.bgMtype:=plane;
 TButton.x:=0.8;
 TButton.y:=0.7;
 TButton.w:=1.2;
 TButton.h:=0.5;
 TButton.ToolTip:='';
 TButton.Text:='';
 TButton.TextSize:=0.8;
 TButton.WordWarp:=true;
 AddControl(TButton);

 TButton:=TO3CustomButton.Create(TOzoneMainClass(ozone).gfxSys,'next');
 TButton.BgModel:=TOzoneMainClass(ozone).gfxSys.CreatePlaneXYModel(0.5,0.5,'button_next.png',BitmapSubDir);
 TButton.bgMtype:=plane;
 TButton.x:=1.05;
 TButton.y:=-0.2;
 TButton.w:=0.5;
 TButton.h:=0.5;
 TButton.ToolTip:='';
 TButton.OnClick:=nlevel;
 AddControl(TButton);

 TButton:=TO3CustomButton.Create(TOzoneMainClass(ozone).gfxSys,'prev');
 TButton.BgModel:=TOzoneMainClass(ozone).gfxSys.CreatePlaneXYModel(0.5,0.5,'button_prev.png',BitmapSubDir);
 TButton.bgMtype:=plane;
 TButton.x:=0.45;
 TButton.y:=-0.2;
 TButton.w:=0.5;
 TButton.h:=0.5;
 TButton.ToolTip:='';
 TButton.OnClick:=plevel;
 AddControl(TButton);

 SetView(0);
end;



end.
