unit o3particles;

interface
 uses dglOpenGL,
      Classes,
      Math,
      o3vectors,
      o3interfaces;
type
 PParticle = ^TParticle;
 TParticleCallBack = procedure(particle:PParticle;timeDelta:integer);
 TParticle = record
  life:integer;
  maxlife:integer;
  color:TVector3d;
  speed:TVector3d;
  pos:TVector3d;
  data:pointer;
  Callback:TParticleCallback;
 end;
 TParticleSystem = class
  particles: TList;
  owner:TO3ParticleSystemGfx;
  procedure render(deltaTime:integer);
  procedure spawn(num:integer;randDir:single;color,speed,pos:TVector3d;Life,LifeRnd:integer;pmax:integer;callback:TParticleCallback;data:pointer);
  procedure clear;
  constructor Create;
  destructor Destory;
 end;

implementation
 uses o3utils;

constructor TParticleSystem.Create;
begin
 inherited Create;
 particles:=TList.Create;
 Randomize;
end;

procedure TParticleSystem.clear;
var x:integer;
begin
 if particles.Count>0 then
  for x:=0 to particles.Count-1 do
   Dispose(particles[x]);
 particles.Clear;  
end;

destructor TParticleSystem.Destory;
begin
 clear;
 particles.Free;
 inherited Destroy;
end;

procedure TParticleSystem.spawn;
var x:integer;
    p:PParticle;
    dir:TVector3d;
begin
 if num<=0 then EXIT;
 for x:=1 to num do begin
  if (pmax>0)and(particles.Count>pmax) then BREAK;
  new(p);
  p.Callback:=callback;
  p.data:=data;
  p.maxlife:=Life+(Random(LifeRnd)-(LifeRnd div 2));
  p.life:=p.maxlife;
  p.color:=color;
  dir:=norm(getVector((random*randDir-randDir/2),(random*randDir-randDir/2),(random*randDir-randDir/2)));
  p.speed:=mulVec(speed,dir);
  p.pos:=pos;
  particles.Add(p);
 end;
end;

procedure TParticleSystem.render;
begin
 owner.RenderParticleSystem(self,deltaTime);
end;

end.
