unit o3sound;

interface
uses SDL,
     openal,
     oooal,
     Classes,
     o3interfaces;
 type TO3SoundSystem_SDL = class(TO3SoundSystem)
       public
        l,o,v:array[0..2] of single;
        procedure UpdateListener(posx,posy,posz:single;ox,oy,oz:single); override;
        function LoadSound(fname:string):Pointer; override;
        function PlaySound(t:Pointer;x,y,z,xv,yv,zv:single;volume:integer=100):pointer; override;
        procedure HaltSound(r:pointer); override;
        procedure FreeSound(p:pointer); override;
//        function PlaySoundLowPriority(t:Pointer;loops:integer;volume:integer=100):byte; override;
        function LoadMusic(fname:string):Pointer; override;
        procedure PlayMusic(t:Pointer;rep:integer); override;
        procedure HaltMusic; override;
        procedure FreeMusic(p:pointer); override;
        procedure SetMusicVolume(volume:integer); override;
        constructor Create(own:pointer); override;
        destructor Destroy; override;
      end;
implementation
 uses o3game;

 procedure TO3SoundSystem_SDL.UpdateListener(posx,posy,posz:single;ox,oy,oz:single);
 begin
  o[0]:=ox;
  o[1]:=oy;
  o[2]:=oz;
  v[0]:=0;
  v[1]:=0;
  v[2]:=0;
//  if (v[0]*v[0]+v[1]*v[1]+v[2]*v[2])>=4 then begin // incorrect velocity - reset to zero
 //  v[0]:=0;
  // v[1]:=0;
  // v[2]:=0;
  //end;
  l[0]:=posx;
  l[1]:=posy;
  l[2]:=posz;
  alListenerfv(AL_POSITION,@l);
  alListenerfv(AL_VELOCITY,@v);
  alListenerfv(AL_ORIENTATION,@o);
 end;
 procedure TO3SoundSystem_SDL.SetMusicVolume;
 begin
  //Mix_VolumeMusic(volume);
 end;

{ function TO3SoundSystem_SDL.PlaySoundLowPriority;
// var x:integer;
 begin
  oo
//  TAlObject(t).Play;
{  Result:=$FF;
  x:=0;
  while (Mix_Playing(x)>0)and(x<=2) do inc(x);
  if x>2 then exit;
  Mix_PlayChannel(x,t,loops);
  Result:=x;
  Mix_Volume(x,volume);}
 //end;

 destructor TO3SoundSystem_SDL.Destroy;
 begin
  //Mix_CloseAudio;
  alutExit;
  inherited Destroy;
 end;

 constructor TO3SoundSystem_SDL.Create;
 begin
  inherited Create(own);
  InitOpenAL;
  alutInit(nil,[]);
//  Mix_OpenAudio(MIX_DEFAULT_FREQUENCY,MIX_DEFAULT_FORMAT,MIX_DEFAULT_CHANNELS,1024);
//  Mix_VolumeMusic(50);
 end;

 function TO3SoundSystem_SDL.PlaySound;
// var x:integer;
 begin
 Result:=TALObject(t).Play(x,y,z,xv,yv,zv);
 if Result<>nil then TALSource(Result).gain:=volume/100;
{  Result:=$FF;
  x:=3;
  while (Mix_Playing(x)>0)and(x<=MIX_CHANNELS) do inc(x);
  if x>MIX_CHANNELS then exit;
  Mix_PlayChannel(x,t,loops);
  Result:=x;
  Mix_Volume(x,volume);}
 end;

 procedure TO3SoundSystem_SDL.HaltSound;
 begin
  TALSource(r).Stop;
  //if r>-1 then Mix_HaltChannel(r);
 end;

 procedure TO3SoundSystem_SDL.FreeSound;
 begin
//  Mix_FreeChunk(p);
  TALObject(p).Free;
 end;

 procedure TO3SoundSystem_SDL.PlayMusic;
 begin
{  if Mix_PlayingMusic>0 then
   Mix_HaltMusic;
  Mix_PlayMusic(t,rep);}
 end;

 procedure TO3SoundSystem_SDL.HaltMusic;
 begin
//  Mix_HaltMusic;
 end;

 procedure TO3SoundSystem_SDL.FreeMusic;
 begin
  //Mix_FreeMusic(p);
 end;

 function TO3SoundSystem_SDL.LoadSound;
 var t:TALUint;
 begin
  //Result:=Mix_LoadWAV(PChar(fname));
//  writeln('1');
  AlGenBuffers(1, @t);
  Result:=TALObject.Create;
  TALObject(Result).LoadFromFile(fname);
//  writeln('2');
 end;

 function TO3SoundSystem_SDL.LoadMusic;
 begin
 // Result:=Mix_LoadMUS(PChar(fname));
 end;
end.
