unit o3specialstones;

interface
uses {$IFDEF WIN32}
      Windows,
     {$ENDIF}
     o3stones,
     o3specialinterface,
     o3opengl,
     o3utils,
     Classes,
     SysUtils,
     o3fpcloader;
type
        TMakeStoneFunc = function(s:string;owner:Pointer):TStone;
        TSpecialStoneLibrary = class(TSpecialLib)
         public
          MakeStone:TMakeStoneFunc;
          constructor Create(name:string;owner:pointer); override;
        end;
        TSpecialStoneAlias = record
         Lib:TSpecialStoneLibrary;
         name:string;
        end;
        TSpecialStoneName = record
         Lib:string;
         name:string;
        end;
        PSpecialStoneAlias = ^TSpecialStoneAlias;
        PSpecialStoneName = ^TSpecialStoneName;
        TSpecialStoneList = class
         private
          FList:TList;
          LList:TList;
          owner:pointer;
          function getObject(s:string):TSpecialStoneLibrary;
          function getLib(s:string):TSpecialStoneLibrary;
         public
          procedure addObject(name,libname:string);
          property Alias[s:string]:TSpecialStoneLibrary read getObject; default;
          property Lib[s:string]:TSpecialStoneLibrary read getLib;
          constructor create(filename:string;own:pointer);
          destructor destroy; override;
        end;

implementation
 uses o3game;
 function TSpecialStoneList.getObject;
 var x:integer;
 begin
  Result:=nil;
  if FList.Count>0 then begin
   for x:=0 to FList.Count-1 do begin
    if (FList.Items[x]<>nil)and(PSpecialStoneName(FList.Items[x])^.name=s) then
     Result:=Lib[PSpecialStoneName(FList.Items[x])^.Lib];
   end;
  end;
 end;

 function TSpecialStoneList.getLib;
 var x:integer;
 begin
  Result:=nil;
  if LList.Count>0 then begin
   for x:=0 to LList.Count-1 do begin
    if (LList.Items[x]<>nil)and(PSpecialStoneAlias(LList.Items[x])^.name=s) then Result:=PSpecialStoneAlias(LList.Items[x])^.Lib;
   end;
  end
 end;

 procedure TSpecialStoneList.addObject;
 var f:PSpecialStoneAlias;
     e:PSpecialStoneName;
 begin
  New(e);
  e^.name:=name;
  e^.Lib:=libname;
  if Lib[libname]=nil then begin
   New(f);
   f^.name:=libname;
   f^.Lib:=TSpecialStoneLibrary.Create(TOzoneMainClass(owner).path+ModelSubDir+libname+LibExt,owner);
   LList.Add(f);
  end;
  FList.Add(e);
 end;

 constructor TSpecialStoneList.create;
 var F:TextFile;
     s,n,fn:string;
 begin
  owner:=own;
  inherited Create;
  DecimalSeparator:='.';
  FList:=TList.Create;
  LList:=TList.Create;
  AssignFile(F,filename);
  Reset(F);
  while(not Eof(F)) do begin
   ReadLn(F,s);
   n:=GetToken(s,1,' ');
   fn:=GetToken(s,2,' ');
   TOzoneMainClass(own).gfxSys.writeProgress('loading '+fn);
   addObject(n,fn);
  end;
  CloseFile(F);
 end;

 destructor TSpecialStoneList.destroy;
 var x:integer;
 begin
  if FList.Count>0 then
   for x:=0 to FList.Count-1 do begin
    if FList.Items[x]<>nil then begin
     Dispose(FList.Items[x]);
    end;
   end;
  FList.Free;
  if LList.Count>0 then
   for x:=0 to LList.Count-1 do begin
    if LList.Items[x]<>nil then begin
     if PSpecialStoneAlias(LList.Items[x])^.Lib<>nil then
      PSpecialStoneAlias(LList.Items[x])^.Lib.Free;
     Dispose(LList.Items[x]);
    end;
   end;
  LList.Free;
  inherited;
 end;

 constructor TSpecialStoneLibrary.Create;
 begin
   inherited;
  if Self<>nil then
    @MakeStone:=GetProcAddress(FHandle,'MakeStone');
 end;


end.
