unit o3stones;

interface
uses o3basicobj,
     SysUtils,
     o3utils;
type
        TStone = class;
        TCollFunc = function(dir:integer;call:TStone;x,y,z:integer;actor:Pointer;level:Pointer;geom:pointer):boolean;
        TStoneInfo = record
         CollFunc:TCollFunc;
         fric:single;
         steer:single;
         antiForce:single;
         mu:single;
        end;
        TStone = class(TO3LevObject)
         public
          collisionCallback:TCollFunc;
          fric:single;
          mu:single;
          steer:single;
          antiForce:single;
          bounceity:single;
          procedure setX(const val:integer); override;
          procedure setY(const val:integer); override;
          procedure setZ(const val:integer); override;
          procedure moveTo(tx,ty,tz:integer); virtual;
          function moveQuery(tx,ty,tz:integer):boolean; virtual;
          constructor Create(name:string;cInfo:string;own:Pointer); reintroduce; virtual;
        end;
        PStone = ^TStone;
implementation
uses o3basicstones,
     o3world,
     o3item,
     o3game;

procedure TStone.moveTo;
begin
    if TLevel(owner).getCell(tx,ty,tz)=nil then exit;
    if not moveQuery(tx,ty,tz) then exit;
    TLevel(owner).getCell(tx,ty,tz).FStone:=self;
    TLevel(owner).getCell(x,y,z).FStone:=nil;
    x:=tx;
    y:=ty;
    z:=tz;
    processMessage('move',[]);
    TOzoneMainClass(TLevel(owner).owner).soundLib.playSound('stone_move',cx,cy,cz);
end;

function TStone.moveQuery;
begin
 Result:=TLevel(owner).getCell(tx,ty,tz).FStone=nil;
end;

procedure TStone.setX;
var Cell:TCell;
    Item:TItem;
begin
 inherited;
 Cell:=TLevel(owner).getCell(fx,fy,fz);
 if cell=nil then Exit;
 Item:=cell.FItem;
 if item=nil then Exit;
 Item.OnStoneOver(self,owner,fx,fy,fz);
end;

procedure TStone.setY;
var Cell:TCell;
    Item:TItem;
begin
 inherited;
 Cell:=TLevel(owner).getCell(fx,fy,fz);
 if cell=nil then Exit;
 Item:=cell.FItem;
 if item=nil then Exit;
 Item.OnStoneOver(self,owner,fx,fy,fz);
end;

procedure TStone.setZ;
var Cell:TCell;
    Item:TItem;
begin
 inherited;
 Cell:=TLevel(owner).getCell(fx,fy,fz);
 if cell=nil then Exit;
 Item:=cell.FItem;
 if item=nil then Exit;
 Item.OnStoneOver(self,owner,fx,fy,fz);
end;

constructor TStone.Create;
begin
 DecimalSeparator:='.';
// t:=stone;
 bounceity:=0.9;
 steer:=1;
 fric:=1;
 mu:=100;
 antiForce:=0;
 inherited Create(name,cInfo,own);
 if info['collision']='block' then
  collisionCallback:=collFuncBlock;
 if info['collision']='model' then
  collisionCallback:=collFuncHole;
 if info['collision']='move' then
  collisionCallback:=collFuncMove;
 if info['collision']='hole' then
  collisionCallback:=collFuncHole;
 if info['bounceity']<>'' then
  bounceity:=StrToFloat(info['bounceity']);
 objectType:=otStone;
end;

end.
