unit o3utils;

interface
uses SysUtils,Classes,ac3d,odeimport,md2,o3m,dglOpenGL;

function GetToken(s:string;c:integer;k:char):string;
function oxydpath:string;
function GetLevelPack(s:string):string;

type
     TModelType = (ac,quake,plane,ozone);
     TItemTexInfo = record
      invList:cardinal;
      invTex:Cardinal;
     end;
     TGfxInfo = record
      highlightColor:TVector4f;
      wireframe:boolean;
      hide:boolean;
     end;
     PGfxInfo = ^TGfxInfo;
     TCallBackable = class
//      objectType:(otCallBackAble,otStone,otItem,otActor);
  //    gfxInfo:PGfxInfo;
    //  FEcharge:integer;
      owner:Pointer;
      freed:boolean;
      //cx,cy,cz:single;
      //procedure setCharge(const val:integer);
      procedure processMessage(m:string;data:array of Pointer); virtual;
      procedure CallBack(delta:integer); virtual;
      //property ECharge:integer read FECharge write setCharge;
      destructor Destroy; override;
      constructor Create; virtual;
     end;
     TInfoList = class;
     TParameterList = class;
     TGameObject = class(TCallBackAble)
      objectType:(otGameObject,otStone,otItem,otActor);
      Info:TInfoList;
      gfxInfo:PGfxInfo;
      visible:boolean;
      gfx:Pointer;
      gfxType:TModelType;
      FEcharge:integer;
      //owner:Pointer;
      //freed:boolean;
      cx,cy,cz:single;
      procedure setCharge(const val:integer);
      function getParameterList:TParameterList; virtual;
      procedure processParameterList(p:TParameterList); virtual;
//      procedure processMessage(m:string;data:array of Pointer); virtual;
//      procedure CallBack(delta:integer); virtual;
      property ECharge:integer read FECharge write setCharge;
      procedure Render(timeDelta:integer); virtual;
      destructor Destroy; override;
      constructor Create; override;
     end;
     TCallBackList = class
      FList:TList;
      procedure Add(call:TCallBackAble);
      procedure Remove(call:TCallBackAble);
      procedure CallBackAll(delta:integer);
      constructor Create;
      destructor Destroy; override;
     end;
     TSignal = class
      source:TGameObject;
      targets:TList;
      constructor create;
      destructor destroy; override;
     end;
     TSignals = class
      FList:TList;
      procedure SendSignal(source:TGameObject;val:integer);
      function find(s:TGameObject):TSignal;
      constructor Create;
      destructor Destroy; override;
     end;

     TDrawProc=procedure(model:pointer;px,py,pz:single;mtype:TModelType);
     PDrawProc=^TDrawProc;
     TPtrInfo = record
      info:string;
      P:Pointer;
     end;
     PPtrInfo = ^TPtrInfo;
     TInfoListEntry = record
                       name:string;
                       info:string;
                      end;
     PInfoListEntry = ^TInfoListEntry;
     TInfoList = class
       private
        FList:TList;
        function find(n:string):PInfoListEntry;
        function getInfo(n:string):string;
        procedure setInfo(n:string;const val:string);
       public
        constructor Create;
        destructor Destroy; override;
        property Info[n:string]:string read getInfo write setInfo; default;
     end;



     TFloatParam = Single;                    // Generic Float
     THeightParam = TFloatParam;              // Y Pos
     TPosParam = array[0..1] of TFloatParam;  // XZ Pos
     TIntParam = Integer;                     // Generic Integer
     TUIntParam = Cardinal;                   // Generic Unsigned Integer
     TBoolParam = Boolean;                    // Generic Boolean
     TMultiChoiceParam = array of string;     // Multiple Choice (Descriptive Array)
     TStringParam = string;                   // Generic String
     TListParam = TParameterList;

     PFloatParam = ^TFloatParam;
     PHeightParam = ^THeightParam;
     PPosParam = ^TPosParam;
     PIntParam = ^TIntParam;
     PUIntParam = ^TUIntParam;
     PBoolParam = ^TBoolParam;
     PMultiChoiceParam = ^TMultiChoiceParam;
     PStringParam = ^TStringParam;
     PListParam = ^TListParam;

     TObjParameterType = (ptFloat,ptHeight,ptPos,ptInt,ptUInt,ptBool,ptMulti,ptString,ptList);

     TObjParameter = class

      pValue: Pointer;
      pType: TObjParameterType;
      desc: string;
      function getFloat:TFloatParam;
      procedure setFloat(const value:TFloatParam);
      function getHeight:THeightParam;
      procedure setHeight(const value:THeightParam);
      function getPos:TPosParam;
      procedure setPos(const value:TPosParam);
      function getInt:TIntParam;
      procedure setInt(const value:TIntParam);
      function getUInt:TUIntParam;
      procedure setUInt(const value:TUIntParam);
      function getBool:TBoolParam;
      procedure setBool(const value:TBoolParam);
      function getMulti:TMultiChoiceParam;
      procedure setMulti(const value:TMultiChoiceParam);
      function getString:TStringParam;
      procedure setString(const value:TStringParam);
      function getList:TListParam;
      procedure setList(const value:TListParam);

      function getPSize:Cardinal;
      function NewP:Pointer;
      procedure disposeP(p:pointer);
      destructor Destroy; override;

      property floatValue:TFloatParam read getFloat write setFloat;
      property heightValue:THeightParam read getHeight write setHeight;
      property posValue:TPosParam read getPos write setPos;
      property intValue:TIntParam read getInt write setInt;
      property uintValue:TUIntParam read getUInt write setUInt;
      property boolValue:TBoolParam read getBool write setBool;
      property multichoiceValue:TMultiChoiceParam read getMulti write setMulti;
      property stringValue:TStringParam read getString write setString;
      property listValue:TListParam read getList write setList;
     end;
     PObjParameter = ^TObjParameter;
     TParameterList = class(TList)
      function getParam(i:integer):TObjParameter;
      destructor destroy; override;
      property params[i:integer]:TObjParameter read getParam; default;
     end;
const ModelSubDir = 'data'+PathDelim+'model'+PathDelim;
      LevelSubDir = 'data'+PathDelim+'levels'+PathDelim;
      ControlSubDir = 'data'+PathDelim+'control'+PathDelim;
      BitmapSubDir = 'data'+PathDelim+'bitmaps'+PathDelim;
      BitmapSubDirQuit = '..'+PathDelim+'..'+PathDelim;
      SoundSubDir = 'data'+PathDelim+'sound'+PathDelim;
      TextureSubDir = ModelSubDir+'textures'+PathDelim;
      ItemTexSubDir = ModelSubDir+'itemtex'+PathDelim;
      MenuModelSubDir = ModelSubDir+'menu'+PathDelim;
      EditorSubDir = LevelSubDir+'editor'+PathDelim;
      MetaSubDir = 'meta'+PathDelim;
      TextureSubRel = 'textures'+PathDelim;
      ItemTexSubRel = 'itemtex'+PathDelim;
      {$IFDEF LINUX}
       LibExt='.so';
      {$ENDIF}
      {$IFDEF WIN32}
       LibExt='.dll';
      {$ENDIF}
      {$IFDEF DARWIN}
       LibExt='.dylib';
      {$ENDIF}
function GetTriMeshFromAC3d(a:TAC3dFile;lev:pointer):PdxTriMeshData;
function GetTriMeshFromO3m(a:TO3mFile;lev:pointer):PdxTriMeshData;
function md2Mat(t:TACMaterial):TQMaterial; overload;
function md2Mat(t:TO3Material):TQMaterial; overload;
function getObjectFromCSV(s:string;level:pointer):TGameObject;
function NewGfxInfo:PGfxInfo;



implementation
uses o3world,o3opengl_font,SDL,o3game;

 destructor TParameterList.destroy;
 var x:integer;
 begin
  if count>0 then
   for x:=0 to count-1 do
    if params[x]<>nil then params[x].Free;
  clear;
  inherited;
 end;

 function TParameterList.getParam(i:integer):TObjParameter;
 begin
  Result:=TObjParameter(self.Items[i]);
 end;

 destructor TObjParameter.Destroy;
 begin
  if pValue<>nil then
   if getPSize>0 then
    disposeP(pValue);
  inherited;
 end;

 function TObjParameter.NewP:Pointer;
 begin
  Result:=nil;
  case pType of
   ptFloat:New(PFloatParam(Result));
   ptHeight:New(PHeightParam(Result));
   ptPos:New(PPosParam(Result));
   ptInt:New(PIntParam(Result));
   ptUInt:New(PUIntParam(Result));
   ptBool:New(PBoolParam(Result));
   ptMulti:New(PMultiChoiceParam(Result));
   ptString:New(PStringParam(Result));
   ptList:Result:=TParameterList.Create;
  end;
 end;
 
 procedure TObjParameter.disposeP(p:pointer);
 begin
  case pType of
   ptFloat:Dispose(PFloatParam(p));
   ptHeight:Dispose(PHeightParam(p));
   ptPos:Dispose(PPosParam(p));
   ptInt:Dispose(PIntParam(p));
   ptUInt:Dispose(PUIntParam(p));
   ptBool:Dispose(PBoolParam(p));
   ptMulti:Dispose(PMultiChoiceParam(p));
   ptString:Dispose(PStringParam(p));
   ptList:TParameterList(p).Free;
  end;
 end;

 function TObjParameter.getPSize:Cardinal;
 begin
  Result:=0;
  case pType of
   ptFloat:Result:=sizeOf(PFloatParam(pValue)^);
   ptHeight:Result:=sizeOf(PHeightParam(pValue)^);
   ptPos:Result:=sizeOf(PPosParam(pValue)^);
   ptInt:Result:=sizeOf(PIntParam(pValue)^);
   ptUInt:Result:=sizeOf(PUIntParam(pValue)^);
   ptBool:Result:=sizeOf(PBoolParam(pValue)^);
   ptMulti:Result:=sizeOf(PMultiChoiceParam(pValue)^);
   ptString:Result:=sizeOf(PStringParam(pValue)^);
   ptList:Result:=sizeOf(Pointer);
  end;
 end;
 function TObjParameter.getList:TListParam;
 begin
  Result:=nil;
  if PType=ptList then Result:=TListParam(pValue);
 end;
 
 procedure TObjParameter.setList(const value:TListParam);
 begin
  if pValue<>nil then disposeP(pValue);
  pType:=ptList;
  //pValue:=newP;
  pValue:=value;
 end;

 function TObjParameter.getFloat:TFloatParam;
 begin
  Result:=0;
  if pType=ptFloat then Result:=PFloatParam(pValue)^;
 end;
 procedure TObjParameter.setFloat(const value:TFloatParam);
 begin
  if pValue<>nil then disposeP(pValue);
  pType:=ptFloat;
  pValue:=newP;
  PFloatParam(pValue)^:=value;
 end;

 function TObjParameter.getHeight:THeightParam;
 begin
  Result:=0;
  if pType=ptHeight then Result:=PHeightParam(pValue)^;
 end;
 procedure TObjParameter.setHeight(const value:THeightParam);
 begin
  if pValue<>nil then disposeP(pValue);
  pType:=ptHeight;
  pValue:=newP;
  PHeightParam(pValue)^:=value;
 end;

 function TObjParameter.getPos:TPosParam;
 begin
  Result[0]:=0;
  Result[1]:=0;
  if pType=ptPos then Result:=PPosParam(pValue)^;
 end;
 procedure TObjParameter.setPos(const value:TPosParam);
 begin
  if pValue<>nil then disposeP(pValue);
  pType:=ptPos;
  pValue:=newP;
  PPosParam(pValue)^:=value;
 end;

 function TObjParameter.getInt:TIntParam;
 begin
  Result:=0;
  if pType=ptInt then Result:=PIntParam(pValue)^;
 end;
 procedure TObjParameter.setInt(const value:TIntParam);
 begin
  if pValue<>nil then disposeP(pValue);
  pType:=ptInt;
  pValue:=newP;
  PIntParam(pValue)^:=value;
 end;

 function TObjParameter.getUInt:TUIntParam;
 begin
  Result:=0;
  if pType=ptUInt then Result:=PUIntParam(pValue)^;
 end;
 procedure TObjParameter.setUInt(const value:TUIntParam);
 begin
  if pValue<>nil then disposeP(pValue);
  pType:=ptUInt;
  pValue:=newP;
  PUIntParam(pValue)^:=value;
 end;

 function TObjParameter.getBool:TBoolParam;
 begin
  Result:=false;
  if pType=ptBool then Result:=PBoolParam(pValue)^;
 end;
 procedure TObjParameter.setBool(const value:TBoolParam);
 begin
  if pValue<>nil then disposeP(pValue);
  pType:=ptBool;
  pValue:=newP;
  PBoolParam(pValue)^:=value;
 end;

 function TObjParameter.getMulti:TMultiChoiceParam;
 begin
  Result:=nil;
  if pType=ptMulti then Result:=PMultiChoiceParam(pValue)^;
 end;
 procedure TObjParameter.setMulti(const value:TMultiChoiceParam);
 begin
  if pValue<>nil then disposeP(pValue);
  pType:=ptMulti;
  pValue:=newP;
  PMultiChoiceParam(pValue)^:=value;
 end;

 function TObjParameter.getString:TStringParam;
 begin
  Result:='';
  if pType=ptString then Result:=PStringParam(pValue)^;
 end;
 procedure TObjParameter.setString(const value:TStringParam);
 begin
  if pValue<>nil then disposeP(pValue);
  pType:=ptString;
  pValue:=newP;
  PStringParam(pValue)^:=value;
 end;



 function NewGfxInfo:PGfxInfo;
 begin
  New(Result);
  Result.highlightColor[0]:=-1;
  Result.wireframe:=false;
  Result.hide:=false;
 end;

 function getObjectFromCSV;
 var a,b,c,d:string;
 begin
  Result:=nil;
  //writeln('getting from csv:'+s);
  a:=GetToken(s,1,',');
  b:=GetToken(s,2,',');
  c:=GetToken(s,3,',');
  d:=GetToken(s,4,',');
  if a='st' then begin
   if (b<>'')and(c<>'')and(d<>'') then
    Result:=TLevel(level).getCell(StrToInt(b),StrToInt(c),StrToInt(d)).FStone;
  end;
  if a='it' then begin
   if (b<>'')and(c<>'')and(d<>'') then
    Result:=TLevel(level).getCell(StrToInt(b),StrToInt(c),StrToInt(d)).FItem;
  end;
  if a='ac' then begin
   if (b<>'') then
    Result:=TLevel(level).FActors.Actor[b];
  end;
 end;


 constructor TSignal.create;
 begin
  inherited Create();
  targets:=TList.create;
 end;

 destructor TSignal.destroy;
 begin
  targets.Free;
  inherited Destroy();
 end;

 procedure TCallBackAble.processMessage;
 begin

 end;

 function TSignals.find;
 var x:integer;
     t:TSignal;
 begin
  Result:=nil;
  if FList.Count>0 then
   for x:=0 to FList.Count-1 do begin
    t:=TSignal(FList[x]);
    if t.source=s then begin
     Result:=t;
     Exit;
    end;
   end;
 end;

 procedure TSignals.SendSignal;
 var x:TSignal;
     i:integer;
 begin
  if source=nil then exit;
  x:=find(source);
  //writeln('sig1:',source.cx-0.5,' ',source.cy-0.5,' ',source.cz-0.5);
  if x=nil then exit;
  //writeln('sig2');
  if x.targets.Count<=0 then exit;
  //writeln('sig3');
  for i:=0 to x.targets.Count-1 do begin
   //writeln('sigsent');
   if x.targets[i]<>nil then
    TGameObject(x.targets[i]).processMessage('signal',[@val,source]);
  end;
 end;

 constructor TSignals.Create;
 begin
  inherited Create();
  FList:=TList.Create;
 end;

 destructor TSignals.Destroy;
 var x:integer;
 begin
  if FList.Count>0 then
   for x:=0 to FList.Count-1 do
    TSignal(FList[x]).Free;
  FList.Free;
  inherited Destroy();
 end;

 function md2Mat(t:TACMaterial):TQMaterial; overload;
 begin
  Result.RGB[0]:=t.RGB.r;
  Result.RGB[1]:=t.RGB.g;
  Result.RGB[2]:=t.RGB.b;
  Result.Ambient[0]:=t.Ambient.r;
  Result.Ambient[1]:=t.Ambient.g;
  Result.Ambient[2]:=t.Ambient.b;
  Result.Specular[0]:=t.Specular.r;
  Result.Specular[1]:=t.Specular.g;
  Result.Specular[2]:=t.Specular.b;
  Result.Emissive[0]:=t.Emissive.r;
  Result.Emissive[1]:=t.Emissive.g;
  Result.Emissive[2]:=t.Emissive.b;
  Result.Shininess:=t.Shininess;
  Result.Alpha:=1-t.Transparency;
 end;

 function md2Mat(t:TO3Material):TQMaterial; overload;
 begin
  Result.RGB[0]:=t.RGB.r;
  Result.RGB[1]:=t.RGB.g;
  Result.RGB[2]:=t.RGB.b;
  Result.Ambient[0]:=t.Ambient.r;
  Result.Ambient[1]:=t.Ambient.g;
  Result.Ambient[2]:=t.Ambient.b;
  Result.Specular[0]:=t.Specular.r;
  Result.Specular[1]:=t.Specular.g;
  Result.Specular[2]:=t.Specular.b;
  Result.Emissive[0]:=t.Emissive.r;
  Result.Emissive[1]:=t.Emissive.g;
  Result.Emissive[2]:=t.Emissive.b;
  Result.Shininess:=t.Shininess;
  Result.Alpha:=1-t.Transparency;
 end;

 function GetTriMeshFromAC3d(a:TAC3dFile;lev:pointer):PdxTriMeshData;
 var
  Vertices : PdVector3Array;
  Indices : PdIntegerArray;
//  Normals : PdVector3Array;
  nc,sc:integer;
  cnt:integer;
 function ACPt(ind:integer):TACPoint;
 begin
  Result.x:=Vertices[Indices[ind],0];
  Result.y:=Vertices[Indices[ind],1];
  Result.z:=Vertices[Indices[ind],2];
 end;
 function V3d(T:TACPoint):TdVector3;
 begin
  Result[0]:=T.x;
  Result[1]:=T.y;
  Result[2]:=T.z;
 end;

 procedure add(ac:ac3d.PACObject);
 var i,j:integer;
 begin
  if (ac.NumSurf>0)and(Copy(ac.Name,1,11)<>'nocollision') then begin
   j:=nc;
   for i:=0 to ac.NumVert-1 do begin
    vertices[j][0]:=ac.Vertices[i].Vertex.x+ac.Loc.x;
    vertices[j][1]:=ac.Vertices[i].Vertex.y+ac.Loc.y;
    vertices[j][2]:=ac.Vertices[i].Vertex.z+ac.Loc.z;
    inc(j);
   end;
   for i:=0 to ac.NumSurf-1 do begin
    if ac.Surfaces[i].NumVertRef=3 then
     indices[sc*3+0]:=ac.Surfaces[i].VertRef[0]+nc;
     indices[sc*3+1]:=ac.Surfaces[i].VertRef[1]+nc;
     indices[sc*3+2]:=ac.Surfaces[i].VertRef[2]+nc;
     inc(sc);
     if (ac.Surfaces[i].Flags and AC_SURFACE_TWOSIDED)=AC_SURFACE_TWOSIDED then begin
      indices[sc*3+2]:=ac.Surfaces[i].VertRef[0]+nc;
      indices[sc*3+1]:=ac.Surfaces[i].VertRef[1]+nc;
      indices[sc*3+0]:=ac.Surfaces[i].VertRef[2]+nc;
      inc(sc);
     end;
   end;
   nc:=j;
  end;
  if ac.NumKids>0 then
   for i:=0 to ac.NumKids-1 do
    add(ac.Kids[i]);
 end;

 begin
//  writeln('ac3d get trimesh');
  new(vertices);
  new(indices);
  for cnt:=0 to Length(Indices^)-1 do
   Indices[cnt]:=0;
  Result:=odeimport.dGeomTriMeshDataCreate;


  Vertices[0,0] := 0;
  Vertices[0,1] := 0;
  Vertices[0,2] := 0;

  Indices[0] := 0;
  Indices[1] := 0;
  Indices[2] := 0;
  sc:=1;
  nc:=3;
  add(a.FObject);
  dGeomTriMeshDataBuildSimple(
    Result,
    Vertices, nc,
    Indices, sc*3);
// -- Debug mode: show physic's model instead of the real ode
{  a.ReleaseDisplayList;
  a.FDispListID:=glGenLists(1);
  glNewList(a.FDispListID,GL_COMPILE);
   glDisable(GL_CULL_FACE);
//   a.SetMaterial(16);
//   glTranslated(0.5,0.5,0.5);
   a.SetMaterial(0);
   glBegin(GL_TRIANGLES);
    for x:=0 to sc*3 do
     glVertex3f(Vertices[Indices[x],0],Vertices[Indices[x],1],Vertices[Indices[x],2]);
   glEnd;
  glEndList;}
// add the data to the level's disposeList.
  TLevel(lev).disposeList.Add(indices);
  TLevel(lev).disposeList.Add(vertices);
 end;
 

 function GetTriMeshFromO3m(a:TO3mFile;lev:pointer):PdxTriMeshData;
 var
  Vertices : PdVector3Array;
  Indices : PdIntegerArray;
  nc,sc:integer;
  cnt:integer;
 function ACPt(ind:integer):TVector3s;
 begin
  Result.x:=Vertices[Indices[ind],0];
  Result.y:=Vertices[Indices[ind],1];
  Result.z:=Vertices[Indices[ind],2];
 end;
 function V3d(T:TVector3s):TdVector3;
 begin
  Result[0]:=T.x;
  Result[1]:=T.y;
  Result[2]:=T.z;
 end;

 procedure add(ac:o3m.PO3Object);
 var i,j:integer;
 begin
   j:=nc;
   if ac.NumSurf>0 then begin
    for i:=0 to ac.NumVert-1 do begin
     vertices[j][0]:=ac.Vertices^[i].Vertex.x+ac.Loc.x;
     vertices[j][1]:=ac.Vertices^[i].Vertex.y+ac.Loc.y;
     vertices[j][2]:=ac.Vertices^[i].Vertex.z+ac.Loc.z;
     inc(j);
    end;
    for i:=0 to ac.NumSurf-1 do begin
      indices[sc*3+0]:=ac.Surfaces^[i].VertRef[0]+nc;
      indices[sc*3+1]:=ac.Surfaces^[i].VertRef[1]+nc;
      indices[sc*3+2]:=ac.Surfaces^[i].VertRef[2]+nc;
      inc(sc);
      if ac.Surfaces^[i].TwoSide then begin
       indices[sc*3+2]:=ac.Surfaces^[i].VertRef[0]+nc;
       indices[sc*3+1]:=ac.Surfaces^[i].VertRef[1]+nc;
       indices[sc*3+0]:=ac.Surfaces^[i].VertRef[2]+nc;
       inc(sc);
      end;
    end;
   end;
   nc:=j;
  if ac.NumKids>0 then
   for i:=0 to ac.NumKids-1 do
    add(ac.Kids^[i]);
 end;

 begin
//  writeln('o3m get trimesh');
  new(vertices);
  new(indices);
  for cnt:=0 to Length(Indices^)-1 do
   Indices[cnt]:=0;
  Result:=odeimport.dGeomTriMeshDataCreate;


  Vertices[0,0] := 0;
  Vertices[0,1] := 0;
  Vertices[0,2] := 0;

  Indices[0] := 0;
  Indices[1] := 0;
  Indices[2] := 0;
  sc:=1;
  nc:=3;
  add(a.FObject);
  dGeomTriMeshDataBuildSimple(
    Result,
    Vertices, nc,
    Indices, sc*3);
  TLevel(lev).disposeList.Add(indices);
  TLevel(lev).disposeList.Add(vertices);
 end;





constructor TCallbackable.Create;
begin
 inherited Create;
// objectType:=otCallBackAble;
 //FECharge:=0;
 Freed:=false;
// cx:=-1;
 //cy:=-1;
 //cz:=-1;
end;

destructor TCallbackable.Destroy;
begin
// ECharge:=0;
 Freed:=true;
// if gfxInfo<>nil then Dispose(gfxInfo);
 inherited Destroy;
end;

function TGameObject.getParameterList:TParameterList;
begin
 Result:=nil;
end;

procedure TGameObject.processParameterList(p:TParameterList);
begin
end;

constructor TGameObject.Create;
begin
 inherited Create;
 visible:=true;
 Info:=TInfoList.Create;
// gfx:=nil;
// gfxType:=ozone;
 objectType:=otGameObject;
 FECharge:=0;
 cx:=-1;
 cy:=-1;
 cz:=-1;
end;

procedure TGameObject.Render;
begin
  if (gfx<>nil) and visible then
        TOzoneMainClass(TLevel(owner).owner).gfxSys.DrawModel(gfx,0,0,0,gfxtype,gfxinfo);
end;

destructor TGameObject.Destroy;
begin
 ECharge:=0;
 Info.Free;
 if gfxInfo<>nil then Dispose(gfxInfo);
 inherited Destroy;
end;

procedure TGameObject.setCharge;
begin
 if FEcharge=val then exit;
 TOzoneMainClass(TLevel(Owner).owner).O3Log.LogStatus('modifiying charge','');
 if TLevel(Owner).physics.ElectricCharged.FList=nil then exit;
 if val=0 then
  TLevel(Owner).physics.ElectricCharged.FList.Remove(self)
 else
  TLevel(Owner).physics.ElectricCharged.FList.add(self);
 FECharge:=val;
 TOzoneMainClass(TLevel(Owner).owner).O3Log.LogStatus('modifiyed charge','');
end;

procedure TCallBackable.CallBack;
begin
end;

constructor TCallBackList.Create;
begin
 inherited Create;
 FList:=TList.Create;
end;

procedure TCallBackList.Add;
begin
 FList.Add(call)
end;

procedure TCallBackList.Remove;
begin
 FList.Remove(call)
end;


procedure TCallBackList.CallBackAll;
var x:integer;
begin
 if FList.Count>0 then
  for x:=0 to FList.Count-1 do
   if x<FList.Count then
    TCallBackable(FList[x]).CallBack(delta);
end;

destructor TCallBackList.Destroy;
var x:integer;
begin
 if FList.Count>0 then
  for x:=0 to FList.Count-1 do
   if FList[x]<>nil then
    if not TCallBackable(FList[x]).freed then
     TCallBackable(FList[x]).Free;
 FList.Clear;    
 FList.Free;
 inherited Destroy;
end;

function TInfoList.find;
var x:integer;
begin
 Result:=nil;
 if FList.Count>0 then begin
  for x:=0 to FList.Count-1 do
   if (FList.Items[x]<>nil) and (PInfoListEntry(FList.Items[x])^.name=n) then
    Result:=FList.Items[x];
 end;
end;

function TInfoList.getInfo;
var P:PInfoListEntry;
begin
 Result:='';
 P:=find(n);
 if P<>nil then
  Result:=P^.info;
end;

procedure TInfoList.setInfo;
var P:PInfoListEntry;
begin
 P:=find(n);
 if P<>nil then
  P^.info:=val
 else begin
  New(P);
  P^.name:=n;
  P^.info:=val;
  FList.Add(P);
 end;
end;

constructor TInfoList.Create;
begin
 inherited;
 FList:=TList.Create;
end;

destructor TInfoList.Destroy;
var x:integer;
begin
 if FList.Count>0 then begin
  for x:=0 to FList.Count-1 do
   if FList.Items[x]<>nil then
    Dispose(FList.Items[x]);
 end;
 FList.Free;
 inherited;
end;

function GetToken;
var
   t   : string;
   Ptr : Integer;
   x   : integer;
begin
   t:='';
   Ptr:=1;
   if c>1 then
      for x:=1 to c-1 do begin
	 while (s[Ptr]<>k)and(Ptr<=Length(s))and(Ptr>0) do begin
	    inc(Ptr);
	 end;
	 inc(Ptr);
      end;
   while (s[Ptr]<>k)and(Ptr<=Length(s))and(Ptr>0) do begin
      t:=t+s[Ptr];
      inc(Ptr);
   end;
   Result:=t;
end;

function oxydpath;
begin
 Result:=ExtractFilePath(ParamStr(0));
end;

function GetLevelPack;
begin
 Result:=LevelSubDir+s+PathDelim;
end;

end.
